import { PingMessage } from './hello.js';
export class HelloClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.Ping.bind(this);
    }
    Ping(request) {
        const data = PingMessage.toJSON(request);
        const promise = this.rpc.request('devvit.actor.hello.Hello', 'Ping', 'application/json', data);
        return promise.then((data) => PingMessage.fromJSON(data));
    }
}
export class HelloClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.Ping.bind(this);
    }
    Ping(request) {
        const data = PingMessage.encode(request).finish();
        const promise = this.rpc.request('devvit.actor.hello.Hello', 'Ping', 'application/protobuf', data);
        return promise.then((data) => PingMessage.decode(data));
    }
}
