import { Args, Arg } from './producer.js';
export class ProducerClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.Produce.bind(this);
    }
    Produce(request) {
        const data = Args.toJSON(request);
        const promise = this.rpc.request('devvit.actor.producer.Producer', 'Produce', 'application/json', data);
        return promise.then((data) => Arg.fromJSON(data));
    }
}
export class ProducerClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.Produce.bind(this);
    }
    Produce(request) {
        const data = Args.encode(request).finish();
        const promise = this.rpc.request('devvit.actor.producer.Producer', 'Produce', 'application/protobuf', data);
        return promise.then((data) => Arg.decode(data));
    }
}
