import { TwirpContext, TwirpServer } from 'twirp-ts';
import { GetFieldsRequest, GetFieldsResponse, ValidateFormRequest, ValidateFormResponse } from './shared.js';
export interface AppSettingsTwirp<T extends TwirpContext = TwirpContext> {
    GetAppSettingsFields(ctx: T, request: GetFieldsRequest): Promise<GetFieldsResponse>;
    ValidateAppForm(ctx: T, request: ValidateFormRequest): Promise<ValidateFormResponse>;
}
export declare enum AppSettingsMethod {
    GetAppSettingsFields = "GetAppSettingsFields",
    ValidateAppForm = "ValidateAppForm"
}
export declare const AppSettingsMethodList: AppSettingsMethod[];
export declare function createAppSettingsServer<T extends TwirpContext = TwirpContext>(service: AppSettingsTwirp<T>): TwirpServer<AppSettingsTwirp<TwirpContext<import("http").IncomingMessage, import("http").ServerResponse<import("http").IncomingMessage>>>, T>;
//# sourceMappingURL=app_settings.twirp.d.ts.map