import { TwirpContext, TwirpServer } from 'twirp-ts';
import { GetFieldsRequest, GetFieldsResponse, ValidateFormRequest, ValidateFormResponse } from './shared.js';
export interface InstallationSettingsTwirp<T extends TwirpContext = TwirpContext> {
    GetSettingsFields(ctx: T, request: GetFieldsRequest): Promise<GetFieldsResponse>;
    ValidateForm(ctx: T, request: ValidateFormRequest): Promise<ValidateFormResponse>;
}
export declare enum InstallationSettingsMethod {
    GetSettingsFields = "GetSettingsFields",
    ValidateForm = "ValidateForm"
}
export declare const InstallationSettingsMethodList: InstallationSettingsMethod[];
export declare function createInstallationSettingsServer<T extends TwirpContext = TwirpContext>(service: InstallationSettingsTwirp<T>): TwirpServer<InstallationSettingsTwirp<TwirpContext<import("http").IncomingMessage, import("http").ServerResponse<import("http").IncomingMessage>>>, T>;
//# sourceMappingURL=installation_settings.twirp.d.ts.map