import { TwirpContext, TwirpServer } from 'twirp-ts';
import { GetFieldsRequest, GetFieldsResponse, ValidateFormRequest, ValidateFormResponse } from './shared.js';
export interface InstanceSettingsTwirp<T extends TwirpContext = TwirpContext> {
    GetSettingsFields(ctx: T, request: GetFieldsRequest): Promise<GetFieldsResponse>;
    ValidateForm(ctx: T, request: ValidateFormRequest): Promise<ValidateFormResponse>;
}
export declare enum InstanceSettingsMethod {
    GetSettingsFields = "GetSettingsFields",
    ValidateForm = "ValidateForm"
}
export declare const InstanceSettingsMethodList: InstanceSettingsMethod[];
export declare function createInstanceSettingsServer<T extends TwirpContext = TwirpContext>(service: InstanceSettingsTwirp<T>): TwirpServer<InstanceSettingsTwirp<TwirpContext<import("http").IncomingMessage, import("http").ServerResponse<import("http").IncomingMessage>>>, T>;
//# sourceMappingURL=instance_settings.twirp.d.ts.map