/**
 * #admin.ts
 *
 * @packageDocumentation
 */
/* eslint-disable */
import _m0 from "protobufjs/minimal.js";
import { Duration } from "../../../../google/protobuf/duration.js";
import { Timestamp } from "../../../../google/protobuf/timestamp.js";
import { messageTypeRegistry } from "../../../../typeRegistry.js";
import { dataTierFromJSON, dataTierToJSON, firehoseEventFromJSON, firehoseEventToJSON, } from "../../../options/options.js";
import { subredditRatingFromJSON, subredditRatingToJSON, } from "../../../reddit/v2alpha/subredditv2.js";
function createBaseDataToken() {
    return { id: "", organizationId: "", createdAt: undefined, expiresAt: undefined, isRevoked: false };
}
export const DataToken = {
    $type: "devvit.data.api.v1alpha.DataToken",
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (message.organizationId !== "") {
            writer.uint32(18).string(message.organizationId);
        }
        if (message.createdAt !== undefined) {
            Timestamp.encode(toTimestamp(message.createdAt), writer.uint32(26).fork()).ldelim();
        }
        if (message.expiresAt !== undefined) {
            Timestamp.encode(toTimestamp(message.expiresAt), writer.uint32(34).fork()).ldelim();
        }
        if (message.isRevoked !== false) {
            writer.uint32(40).bool(message.isRevoked);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDataToken();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 10) {
                        break;
                    }
                    message.id = reader.string();
                    continue;
                case 2:
                    if (tag !== 18) {
                        break;
                    }
                    message.organizationId = reader.string();
                    continue;
                case 3:
                    if (tag !== 26) {
                        break;
                    }
                    message.createdAt = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    continue;
                case 4:
                    if (tag !== 34) {
                        break;
                    }
                    message.expiresAt = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    continue;
                case 5:
                    if (tag !== 40) {
                        break;
                    }
                    message.isRevoked = reader.bool();
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? globalThis.String(object.id) : "",
            organizationId: isSet(object.organizationId) ? globalThis.String(object.organizationId) : "",
            createdAt: isSet(object.createdAt) ? fromJsonTimestamp(object.createdAt) : undefined,
            expiresAt: isSet(object.expiresAt) ? fromJsonTimestamp(object.expiresAt) : undefined,
            isRevoked: isSet(object.isRevoked) ? globalThis.Boolean(object.isRevoked) : false,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.id !== "") {
            obj.id = message.id;
        }
        if (message.organizationId !== "") {
            obj.organizationId = message.organizationId;
        }
        if (message.createdAt !== undefined) {
            obj.createdAt = message.createdAt.toISOString();
        }
        if (message.expiresAt !== undefined) {
            obj.expiresAt = message.expiresAt.toISOString();
        }
        if (message.isRevoked !== false) {
            obj.isRevoked = message.isRevoked;
        }
        return obj;
    },
    create(base) {
        return DataToken.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseDataToken();
        message.id = object.id ?? "";
        message.organizationId = object.organizationId ?? "";
        message.createdAt = object.createdAt ?? undefined;
        message.expiresAt = object.expiresAt ?? undefined;
        message.isRevoked = object.isRevoked ?? false;
        return message;
    },
};
messageTypeRegistry.set(DataToken.$type, DataToken);
function createBaseDataSubscription() {
    return {
        id: "",
        tier: 0,
        events: [],
        subreddits: [],
        subredditRatings: [],
        organizationId: "",
        name: "",
        description: undefined,
    };
}
export const DataSubscription = {
    $type: "devvit.data.api.v1alpha.DataSubscription",
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (message.tier !== 0) {
            writer.uint32(16).int32(message.tier);
        }
        writer.uint32(26).fork();
        for (const v of message.events) {
            writer.int32(v);
        }
        writer.ldelim();
        for (const v of message.subreddits) {
            writer.uint32(34).string(v);
        }
        writer.uint32(42).fork();
        for (const v of message.subredditRatings) {
            writer.int32(v);
        }
        writer.ldelim();
        if (message.organizationId !== "") {
            writer.uint32(50).string(message.organizationId);
        }
        if (message.name !== "") {
            writer.uint32(58).string(message.name);
        }
        if (message.description !== undefined) {
            writer.uint32(66).string(message.description);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDataSubscription();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 10) {
                        break;
                    }
                    message.id = reader.string();
                    continue;
                case 2:
                    if (tag !== 16) {
                        break;
                    }
                    message.tier = reader.int32();
                    continue;
                case 3:
                    if (tag === 24) {
                        message.events.push(reader.int32());
                        continue;
                    }
                    if (tag === 26) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.events.push(reader.int32());
                        }
                        continue;
                    }
                    break;
                case 4:
                    if (tag !== 34) {
                        break;
                    }
                    message.subreddits.push(reader.string());
                    continue;
                case 5:
                    if (tag === 40) {
                        message.subredditRatings.push(reader.int32());
                        continue;
                    }
                    if (tag === 42) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.subredditRatings.push(reader.int32());
                        }
                        continue;
                    }
                    break;
                case 6:
                    if (tag !== 50) {
                        break;
                    }
                    message.organizationId = reader.string();
                    continue;
                case 7:
                    if (tag !== 58) {
                        break;
                    }
                    message.name = reader.string();
                    continue;
                case 8:
                    if (tag !== 66) {
                        break;
                    }
                    message.description = reader.string();
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? globalThis.String(object.id) : "",
            tier: isSet(object.tier) ? dataTierFromJSON(object.tier) : 0,
            events: globalThis.Array.isArray(object?.events) ? object.events.map((e) => firehoseEventFromJSON(e)) : [],
            subreddits: globalThis.Array.isArray(object?.subreddits)
                ? object.subreddits.map((e) => globalThis.String(e))
                : [],
            subredditRatings: globalThis.Array.isArray(object?.subredditRatings)
                ? object.subredditRatings.map((e) => subredditRatingFromJSON(e))
                : [],
            organizationId: isSet(object.organizationId) ? globalThis.String(object.organizationId) : "",
            name: isSet(object.name) ? globalThis.String(object.name) : "",
            description: isSet(object.description) ? globalThis.String(object.description) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.id !== "") {
            obj.id = message.id;
        }
        if (message.tier !== 0) {
            obj.tier = dataTierToJSON(message.tier);
        }
        if (message.events?.length) {
            obj.events = message.events.map((e) => firehoseEventToJSON(e));
        }
        if (message.subreddits?.length) {
            obj.subreddits = message.subreddits;
        }
        if (message.subredditRatings?.length) {
            obj.subredditRatings = message.subredditRatings.map((e) => subredditRatingToJSON(e));
        }
        if (message.organizationId !== "") {
            obj.organizationId = message.organizationId;
        }
        if (message.name !== "") {
            obj.name = message.name;
        }
        if (message.description !== undefined) {
            obj.description = message.description;
        }
        return obj;
    },
    create(base) {
        return DataSubscription.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseDataSubscription();
        message.id = object.id ?? "";
        message.tier = object.tier ?? 0;
        message.events = object.events?.map((e) => e) || [];
        message.subreddits = object.subreddits?.map((e) => e) || [];
        message.subredditRatings = object.subredditRatings?.map((e) => e) || [];
        message.organizationId = object.organizationId ?? "";
        message.name = object.name ?? "";
        message.description = object.description ?? undefined;
        return message;
    },
};
messageTypeRegistry.set(DataSubscription.$type, DataSubscription);
function createBaseOrganization() {
    return { id: "", name: "", subscriptions: [], tokens: [], contractEndDate: undefined };
}
export const Organization = {
    $type: "devvit.data.api.v1alpha.Organization",
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (message.name !== "") {
            writer.uint32(18).string(message.name);
        }
        for (const v of message.subscriptions) {
            DataSubscription.encode(v, writer.uint32(26).fork()).ldelim();
        }
        for (const v of message.tokens) {
            DataToken.encode(v, writer.uint32(34).fork()).ldelim();
        }
        if (message.contractEndDate !== undefined) {
            Timestamp.encode(toTimestamp(message.contractEndDate), writer.uint32(42).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseOrganization();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 10) {
                        break;
                    }
                    message.id = reader.string();
                    continue;
                case 2:
                    if (tag !== 18) {
                        break;
                    }
                    message.name = reader.string();
                    continue;
                case 3:
                    if (tag !== 26) {
                        break;
                    }
                    message.subscriptions.push(DataSubscription.decode(reader, reader.uint32()));
                    continue;
                case 4:
                    if (tag !== 34) {
                        break;
                    }
                    message.tokens.push(DataToken.decode(reader, reader.uint32()));
                    continue;
                case 5:
                    if (tag !== 42) {
                        break;
                    }
                    message.contractEndDate = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? globalThis.String(object.id) : "",
            name: isSet(object.name) ? globalThis.String(object.name) : "",
            subscriptions: globalThis.Array.isArray(object?.subscriptions)
                ? object.subscriptions.map((e) => DataSubscription.fromJSON(e))
                : [],
            tokens: globalThis.Array.isArray(object?.tokens) ? object.tokens.map((e) => DataToken.fromJSON(e)) : [],
            contractEndDate: isSet(object.contractEndDate) ? fromJsonTimestamp(object.contractEndDate) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.id !== "") {
            obj.id = message.id;
        }
        if (message.name !== "") {
            obj.name = message.name;
        }
        if (message.subscriptions?.length) {
            obj.subscriptions = message.subscriptions.map((e) => DataSubscription.toJSON(e));
        }
        if (message.tokens?.length) {
            obj.tokens = message.tokens.map((e) => DataToken.toJSON(e));
        }
        if (message.contractEndDate !== undefined) {
            obj.contractEndDate = message.contractEndDate.toISOString();
        }
        return obj;
    },
    create(base) {
        return Organization.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseOrganization();
        message.id = object.id ?? "";
        message.name = object.name ?? "";
        message.subscriptions = object.subscriptions?.map((e) => DataSubscription.fromPartial(e)) || [];
        message.tokens = object.tokens?.map((e) => DataToken.fromPartial(e)) || [];
        message.contractEndDate = object.contractEndDate ?? undefined;
        return message;
    },
};
messageTypeRegistry.set(Organization.$type, Organization);
function createBaseDataApiAuthTokenRequest() {
    return { customer: "", expiresIn: undefined };
}
export const DataApiAuthTokenRequest = {
    $type: "devvit.data.api.v1alpha.DataApiAuthTokenRequest",
    encode(message, writer = _m0.Writer.create()) {
        if (message.customer !== "") {
            writer.uint32(10).string(message.customer);
        }
        if (message.expiresIn !== undefined) {
            Duration.encode(message.expiresIn, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDataApiAuthTokenRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 10) {
                        break;
                    }
                    message.customer = reader.string();
                    continue;
                case 2:
                    if (tag !== 18) {
                        break;
                    }
                    message.expiresIn = Duration.decode(reader, reader.uint32());
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            customer: isSet(object.customer) ? globalThis.String(object.customer) : "",
            expiresIn: isSet(object.expiresIn) ? Duration.fromJSON(object.expiresIn) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.customer !== "") {
            obj.customer = message.customer;
        }
        if (message.expiresIn !== undefined) {
            obj.expiresIn = Duration.toJSON(message.expiresIn);
        }
        return obj;
    },
    create(base) {
        return DataApiAuthTokenRequest.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseDataApiAuthTokenRequest();
        message.customer = object.customer ?? "";
        message.expiresIn = (object.expiresIn !== undefined && object.expiresIn !== null)
            ? Duration.fromPartial(object.expiresIn)
            : undefined;
        return message;
    },
};
messageTypeRegistry.set(DataApiAuthTokenRequest.$type, DataApiAuthTokenRequest);
function createBaseDataApiAuthTokenResponse() {
    return { id: "", token: "", expiresAt: undefined };
}
export const DataApiAuthTokenResponse = {
    $type: "devvit.data.api.v1alpha.DataApiAuthTokenResponse",
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== "") {
            writer.uint32(10).string(message.id);
        }
        if (message.token !== "") {
            writer.uint32(18).string(message.token);
        }
        if (message.expiresAt !== undefined) {
            Timestamp.encode(toTimestamp(message.expiresAt), writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDataApiAuthTokenResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 10) {
                        break;
                    }
                    message.id = reader.string();
                    continue;
                case 2:
                    if (tag !== 18) {
                        break;
                    }
                    message.token = reader.string();
                    continue;
                case 3:
                    if (tag !== 26) {
                        break;
                    }
                    message.expiresAt = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? globalThis.String(object.id) : "",
            token: isSet(object.token) ? globalThis.String(object.token) : "",
            expiresAt: isSet(object.expiresAt) ? fromJsonTimestamp(object.expiresAt) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.id !== "") {
            obj.id = message.id;
        }
        if (message.token !== "") {
            obj.token = message.token;
        }
        if (message.expiresAt !== undefined) {
            obj.expiresAt = message.expiresAt.toISOString();
        }
        return obj;
    },
    create(base) {
        return DataApiAuthTokenResponse.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseDataApiAuthTokenResponse();
        message.id = object.id ?? "";
        message.token = object.token ?? "";
        message.expiresAt = object.expiresAt ?? undefined;
        return message;
    },
};
messageTypeRegistry.set(DataApiAuthTokenResponse.$type, DataApiAuthTokenResponse);
export const DataApiAuthTokenIssuerServiceName = "devvit.data.api.v1alpha.DataApiAuthTokenIssuer";
export class DataApiAuthTokenIssuerClientImpl {
    constructor(rpc, opts) {
        this.service = opts?.service || DataApiAuthTokenIssuerServiceName;
        this.rpc = rpc;
        this.GenerateAuthToken = this.GenerateAuthToken.bind(this);
    }
    GenerateAuthToken(request, metadata) {
        const data = DataApiAuthTokenRequest.encode(request).finish();
        const promise = this.rpc.request(this.service, "GenerateAuthToken", data, metadata);
        return promise.then((data) => DataApiAuthTokenResponse.decode(_m0.Reader.create(data)));
    }
}
export const DataApiAuthTokenIssuerDefinition = {
    name: "DataApiAuthTokenIssuer",
    fullName: "devvit.data.api.v1alpha.DataApiAuthTokenIssuer",
    methods: {
        generateAuthToken: {
            name: "GenerateAuthToken",
            requestType: DataApiAuthTokenRequest,
            requestStream: false,
            responseType: DataApiAuthTokenResponse,
            responseStream: false,
            options: {},
        },
    },
};
function toTimestamp(date) {
    const seconds = Math.trunc(date.getTime() / 1000);
    const nanos = (date.getTime() % 1000) * 1000000;
    return { seconds, nanos };
}
function fromTimestamp(t) {
    let millis = (t.seconds || 0) * 1000;
    millis += (t.nanos || 0) / 1000000;
    return new globalThis.Date(millis);
}
function fromJsonTimestamp(o) {
    if (o instanceof globalThis.Date) {
        return o;
    }
    else if (typeof o === "string") {
        return new globalThis.Date(o);
    }
    else {
        return fromTimestamp(Timestamp.fromJSON(o));
    }
}
function isSet(value) {
    return value !== null && value !== undefined;
}
