import { GetProfileRequest, GetProfileResponse } from './debug.js';
export class DevvitProfilerClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.GetProfile.bind(this);
    }
    GetProfile(request) {
        const data = GetProfileRequest.toJSON(request);
        const promise = this.rpc.request('devvit.debug.v1alpha.DevvitProfiler', 'GetProfile', 'application/json', data);
        return promise.then((data) => GetProfileResponse.fromJSON(data));
    }
}
export class DevvitProfilerClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.GetProfile.bind(this);
    }
    GetProfile(request) {
        const data = GetProfileRequest.encode(request).finish();
        const promise = this.rpc.request('devvit.debug.v1alpha.DevvitProfiler', 'GetProfile', 'application/protobuf', data);
        return promise.then((data) => GetProfileResponse.decode(data));
    }
}
