/**
 * #app_settings.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { SettingsValues } from "../../plugin/settings/v1alpha/settings.js";
import { Form } from "../../ui/form_builder/v1alpha/form.js";
export interface GetAppSettingsRequest {
    appId: string;
}
export interface GetAppSettingsResponse {
    settings?: SettingsValues | undefined;
}
export interface UpdateAppSettingsRequest {
    appId: string;
    settings?: SettingsValues | undefined;
}
export interface UpdateAppSettingsResponse {
    success: boolean;
    errors: {
        [key: string]: string;
    };
}
export interface UpdateAppSettingsResponse_ErrorsEntry {
    key: string;
    value: string;
}
export interface GetAppSettingsFormRequest {
    appId: string;
}
export interface GetAppSettingsFormResponse {
    /** App settings Forms mapped by actor_name */
    form: {
        [key: string]: Form;
    };
}
export interface GetAppSettingsFormResponse_FormEntry {
    key: string;
    value?: Form | undefined;
}
export interface ValidateAppSettingsFormRequest {
    appId: string;
    settings?: SettingsValues | undefined;
}
export interface ValidateAppSettingsFormResponse {
    /** If false, prevent submission and display errors on the form */
    success: boolean;
    /** Map of field_id:error pairs to display on the form */
    errors: {
        [key: string]: string;
    };
}
export interface ValidateAppSettingsFormResponse_ErrorsEntry {
    key: string;
    value: string;
}
export declare const GetAppSettingsRequest: {
    $type: "devvit.dev_portal.app_settings.GetAppSettingsRequest";
    encode(message: GetAppSettingsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetAppSettingsRequest;
    fromJSON(object: any): GetAppSettingsRequest;
    toJSON(message: GetAppSettingsRequest): unknown;
    create(base?: DeepPartial<GetAppSettingsRequest>): GetAppSettingsRequest;
    fromPartial(object: DeepPartial<GetAppSettingsRequest>): GetAppSettingsRequest;
};
export declare const GetAppSettingsResponse: {
    $type: "devvit.dev_portal.app_settings.GetAppSettingsResponse";
    encode(message: GetAppSettingsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetAppSettingsResponse;
    fromJSON(object: any): GetAppSettingsResponse;
    toJSON(message: GetAppSettingsResponse): unknown;
    create(base?: DeepPartial<GetAppSettingsResponse>): GetAppSettingsResponse;
    fromPartial(object: DeepPartial<GetAppSettingsResponse>): GetAppSettingsResponse;
};
export declare const UpdateAppSettingsRequest: {
    $type: "devvit.dev_portal.app_settings.UpdateAppSettingsRequest";
    encode(message: UpdateAppSettingsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateAppSettingsRequest;
    fromJSON(object: any): UpdateAppSettingsRequest;
    toJSON(message: UpdateAppSettingsRequest): unknown;
    create(base?: DeepPartial<UpdateAppSettingsRequest>): UpdateAppSettingsRequest;
    fromPartial(object: DeepPartial<UpdateAppSettingsRequest>): UpdateAppSettingsRequest;
};
export declare const UpdateAppSettingsResponse: {
    $type: "devvit.dev_portal.app_settings.UpdateAppSettingsResponse";
    encode(message: UpdateAppSettingsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateAppSettingsResponse;
    fromJSON(object: any): UpdateAppSettingsResponse;
    toJSON(message: UpdateAppSettingsResponse): unknown;
    create(base?: DeepPartial<UpdateAppSettingsResponse>): UpdateAppSettingsResponse;
    fromPartial(object: DeepPartial<UpdateAppSettingsResponse>): UpdateAppSettingsResponse;
};
export declare const UpdateAppSettingsResponse_ErrorsEntry: {
    $type: "devvit.dev_portal.app_settings.UpdateAppSettingsResponse.ErrorsEntry";
    encode(message: UpdateAppSettingsResponse_ErrorsEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateAppSettingsResponse_ErrorsEntry;
    fromJSON(object: any): UpdateAppSettingsResponse_ErrorsEntry;
    toJSON(message: UpdateAppSettingsResponse_ErrorsEntry): unknown;
    create(base?: DeepPartial<UpdateAppSettingsResponse_ErrorsEntry>): UpdateAppSettingsResponse_ErrorsEntry;
    fromPartial(object: DeepPartial<UpdateAppSettingsResponse_ErrorsEntry>): UpdateAppSettingsResponse_ErrorsEntry;
};
export declare const GetAppSettingsFormRequest: {
    $type: "devvit.dev_portal.app_settings.GetAppSettingsFormRequest";
    encode(message: GetAppSettingsFormRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetAppSettingsFormRequest;
    fromJSON(object: any): GetAppSettingsFormRequest;
    toJSON(message: GetAppSettingsFormRequest): unknown;
    create(base?: DeepPartial<GetAppSettingsFormRequest>): GetAppSettingsFormRequest;
    fromPartial(object: DeepPartial<GetAppSettingsFormRequest>): GetAppSettingsFormRequest;
};
export declare const GetAppSettingsFormResponse: {
    $type: "devvit.dev_portal.app_settings.GetAppSettingsFormResponse";
    encode(message: GetAppSettingsFormResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetAppSettingsFormResponse;
    fromJSON(object: any): GetAppSettingsFormResponse;
    toJSON(message: GetAppSettingsFormResponse): unknown;
    create(base?: DeepPartial<GetAppSettingsFormResponse>): GetAppSettingsFormResponse;
    fromPartial(object: DeepPartial<GetAppSettingsFormResponse>): GetAppSettingsFormResponse;
};
export declare const GetAppSettingsFormResponse_FormEntry: {
    $type: "devvit.dev_portal.app_settings.GetAppSettingsFormResponse.FormEntry";
    encode(message: GetAppSettingsFormResponse_FormEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetAppSettingsFormResponse_FormEntry;
    fromJSON(object: any): GetAppSettingsFormResponse_FormEntry;
    toJSON(message: GetAppSettingsFormResponse_FormEntry): unknown;
    create(base?: DeepPartial<GetAppSettingsFormResponse_FormEntry>): GetAppSettingsFormResponse_FormEntry;
    fromPartial(object: DeepPartial<GetAppSettingsFormResponse_FormEntry>): GetAppSettingsFormResponse_FormEntry;
};
export declare const ValidateAppSettingsFormRequest: {
    $type: "devvit.dev_portal.app_settings.ValidateAppSettingsFormRequest";
    encode(message: ValidateAppSettingsFormRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidateAppSettingsFormRequest;
    fromJSON(object: any): ValidateAppSettingsFormRequest;
    toJSON(message: ValidateAppSettingsFormRequest): unknown;
    create(base?: DeepPartial<ValidateAppSettingsFormRequest>): ValidateAppSettingsFormRequest;
    fromPartial(object: DeepPartial<ValidateAppSettingsFormRequest>): ValidateAppSettingsFormRequest;
};
export declare const ValidateAppSettingsFormResponse: {
    $type: "devvit.dev_portal.app_settings.ValidateAppSettingsFormResponse";
    encode(message: ValidateAppSettingsFormResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidateAppSettingsFormResponse;
    fromJSON(object: any): ValidateAppSettingsFormResponse;
    toJSON(message: ValidateAppSettingsFormResponse): unknown;
    create(base?: DeepPartial<ValidateAppSettingsFormResponse>): ValidateAppSettingsFormResponse;
    fromPartial(object: DeepPartial<ValidateAppSettingsFormResponse>): ValidateAppSettingsFormResponse;
};
export declare const ValidateAppSettingsFormResponse_ErrorsEntry: {
    $type: "devvit.dev_portal.app_settings.ValidateAppSettingsFormResponse.ErrorsEntry";
    encode(message: ValidateAppSettingsFormResponse_ErrorsEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidateAppSettingsFormResponse_ErrorsEntry;
    fromJSON(object: any): ValidateAppSettingsFormResponse_ErrorsEntry;
    toJSON(message: ValidateAppSettingsFormResponse_ErrorsEntry): unknown;
    create(base?: DeepPartial<ValidateAppSettingsFormResponse_ErrorsEntry>): ValidateAppSettingsFormResponse_ErrorsEntry;
    fromPartial(object: DeepPartial<ValidateAppSettingsFormResponse_ErrorsEntry>): ValidateAppSettingsFormResponse_ErrorsEntry;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=app_settings.d.ts.map