/**
 * #app_version_info.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { NutritionCategory } from "../../nutrition/nutrition.js";
export declare enum VersionVisibility {
    PUBLIC = 0,
    PRIVATE = 1,
    UNLISTED = 2,
    UNRECOGNIZED = -1
}
export declare function versionVisibilityFromJSON(object: any): VersionVisibility;
export declare function versionVisibilityToJSON(object: VersionVisibility): number;
export declare enum BuildStatus {
    BUILDING = 0,
    READY = 1,
    FAILED = 2,
    UNRECOGNIZED = -1
}
export declare function buildStatusFromJSON(object: any): BuildStatus;
export declare function buildStatusToJSON(object: BuildStatus): number;
export declare enum InstallationType {
    USER = 0,
    SUBREDDIT = 1,
    SUBREDDIT_GLOBAL = 2,
    UNRECOGNIZED = -1
}
export declare function installationTypeFromJSON(object: any): InstallationType;
export declare function installationTypeToJSON(object: InstallationType): number;
export declare enum ComputePool {
    LOW = 0,
    /** @deprecated */
    MEDIUM = 1,
    HIGH = 2,
    RESTRICTED = 3,
    INTERNAL = 4,
    BETA = 5,
    UNRECOGNIZED = -1
}
export declare function computePoolFromJSON(object: any): ComputePool;
export declare function computePoolToJSON(object: ComputePool): number;
export interface OptionalVersionVisibility {
    value: VersionVisibility;
}
/** Contains the details of an app version. For field documentation, refer to the Prisma schema. */
export interface AppVersionInfo {
    id: string;
    visibility: VersionVisibility;
    validInstallTypes: InstallationType[];
    majorVersion: number;
    minorVersion: number;
    patchVersion: number;
    prereleaseVersion?: number | undefined;
    uploadedAt?: Date | undefined;
    buildStatus: BuildStatus;
    builtAt?: Date | undefined;
    about: string;
    hasCustomSettings: boolean;
    pool: ComputePool;
    /** Abstract plugin capabilities used by the target app version */
    appCapabilities: NutritionCategory[];
    /** Devvit API version of this app version (e.g. "1.0.0") */
    publicApiVersion?: string | undefined;
}
export declare const OptionalVersionVisibility: {
    $type: "devvit.dev_portal.app_version.info.OptionalVersionVisibility";
    encode(message: OptionalVersionVisibility, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): OptionalVersionVisibility;
    fromJSON(object: any): OptionalVersionVisibility;
    toJSON(message: OptionalVersionVisibility): unknown;
    create(base?: DeepPartial<OptionalVersionVisibility>): OptionalVersionVisibility;
    fromPartial(object: DeepPartial<OptionalVersionVisibility>): OptionalVersionVisibility;
};
export declare const AppVersionInfo: {
    $type: "devvit.dev_portal.app_version.info.AppVersionInfo";
    encode(message: AppVersionInfo, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AppVersionInfo;
    fromJSON(object: any): AppVersionInfo;
    toJSON(message: AppVersionInfo): unknown;
    create(base?: DeepPartial<AppVersionInfo>): AppVersionInfo;
    fromPartial(object: DeepPartial<AppVersionInfo>): AppVersionInfo;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=app_version_info.d.ts.map