/**
 * #organization.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { Organization } from "../../../../data/api/v1alpha/admin.js";
export interface CreateOrganizationRequest {
    name: string;
    contractEndDate?: Date | undefined;
    /** Indicates if the organization is an internal or external organization */
    isInternal: boolean;
}
export interface CreateOrganizationResponse {
    organizationId: string;
    name: string;
}
export interface GetOrganizationByNameRequest {
    name: string;
}
export interface GetOrganizationByNameResponse {
    organizationId: string;
    isInternal: boolean;
}
export interface GetOrganizationsRequest {
}
export interface GetOrganizationsResponse {
    organizations: Organization[];
}
export interface UpdateOrganizationRequest {
    organizationId: string;
    isInternal: boolean;
}
export interface UpdateOrganizationResponse {
}
export declare const CreateOrganizationRequest: {
    $type: "devvit.dev_portal.data_api.admin.organization.CreateOrganizationRequest";
    encode(message: CreateOrganizationRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CreateOrganizationRequest;
    fromJSON(object: any): CreateOrganizationRequest;
    toJSON(message: CreateOrganizationRequest): unknown;
    create(base?: DeepPartial<CreateOrganizationRequest>): CreateOrganizationRequest;
    fromPartial(object: DeepPartial<CreateOrganizationRequest>): CreateOrganizationRequest;
};
export declare const CreateOrganizationResponse: {
    $type: "devvit.dev_portal.data_api.admin.organization.CreateOrganizationResponse";
    encode(message: CreateOrganizationResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CreateOrganizationResponse;
    fromJSON(object: any): CreateOrganizationResponse;
    toJSON(message: CreateOrganizationResponse): unknown;
    create(base?: DeepPartial<CreateOrganizationResponse>): CreateOrganizationResponse;
    fromPartial(object: DeepPartial<CreateOrganizationResponse>): CreateOrganizationResponse;
};
export declare const GetOrganizationByNameRequest: {
    $type: "devvit.dev_portal.data_api.admin.organization.GetOrganizationByNameRequest";
    encode(message: GetOrganizationByNameRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetOrganizationByNameRequest;
    fromJSON(object: any): GetOrganizationByNameRequest;
    toJSON(message: GetOrganizationByNameRequest): unknown;
    create(base?: DeepPartial<GetOrganizationByNameRequest>): GetOrganizationByNameRequest;
    fromPartial(object: DeepPartial<GetOrganizationByNameRequest>): GetOrganizationByNameRequest;
};
export declare const GetOrganizationByNameResponse: {
    $type: "devvit.dev_portal.data_api.admin.organization.GetOrganizationByNameResponse";
    encode(message: GetOrganizationByNameResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetOrganizationByNameResponse;
    fromJSON(object: any): GetOrganizationByNameResponse;
    toJSON(message: GetOrganizationByNameResponse): unknown;
    create(base?: DeepPartial<GetOrganizationByNameResponse>): GetOrganizationByNameResponse;
    fromPartial(object: DeepPartial<GetOrganizationByNameResponse>): GetOrganizationByNameResponse;
};
export declare const GetOrganizationsRequest: {
    $type: "devvit.dev_portal.data_api.admin.organization.GetOrganizationsRequest";
    encode(_: GetOrganizationsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetOrganizationsRequest;
    fromJSON(_: any): GetOrganizationsRequest;
    toJSON(_: GetOrganizationsRequest): unknown;
    create(base?: DeepPartial<GetOrganizationsRequest>): GetOrganizationsRequest;
    fromPartial(_: DeepPartial<GetOrganizationsRequest>): GetOrganizationsRequest;
};
export declare const GetOrganizationsResponse: {
    $type: "devvit.dev_portal.data_api.admin.organization.GetOrganizationsResponse";
    encode(message: GetOrganizationsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetOrganizationsResponse;
    fromJSON(object: any): GetOrganizationsResponse;
    toJSON(message: GetOrganizationsResponse): unknown;
    create(base?: DeepPartial<GetOrganizationsResponse>): GetOrganizationsResponse;
    fromPartial(object: DeepPartial<GetOrganizationsResponse>): GetOrganizationsResponse;
};
export declare const UpdateOrganizationRequest: {
    $type: "devvit.dev_portal.data_api.admin.organization.UpdateOrganizationRequest";
    encode(message: UpdateOrganizationRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateOrganizationRequest;
    fromJSON(object: any): UpdateOrganizationRequest;
    toJSON(message: UpdateOrganizationRequest): unknown;
    create(base?: DeepPartial<UpdateOrganizationRequest>): UpdateOrganizationRequest;
    fromPartial(object: DeepPartial<UpdateOrganizationRequest>): UpdateOrganizationRequest;
};
export declare const UpdateOrganizationResponse: {
    $type: "devvit.dev_portal.data_api.admin.organization.UpdateOrganizationResponse";
    encode(_: UpdateOrganizationResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateOrganizationResponse;
    fromJSON(_: any): UpdateOrganizationResponse;
    toJSON(_: UpdateOrganizationResponse): unknown;
    create(base?: DeepPartial<UpdateOrganizationResponse>): UpdateOrganizationResponse;
    fromPartial(_: DeepPartial<UpdateOrganizationResponse>): UpdateOrganizationResponse;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=organization.d.ts.map