/**
 * #fetch_domain.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
/** Represents a domain's global status. UNDECIDED means the domain is not globally decided, ie only applies at the app level. */
export declare enum FetchDomainGlobalStatus {
    UNDECIDED = 0,
    ALLOWED = 1,
    DENIED = 2,
    UNRECOGNIZED = -1
}
export declare function fetchDomainGlobalStatusFromJSON(object: any): FetchDomainGlobalStatus;
export declare function fetchDomainGlobalStatusToJSON(object: FetchDomainGlobalStatus): number;
export interface FetchDomain {
    /** The domain name, eg 'api.stlouisfed.org' */
    domain: string;
    /** The status of the domain, one of UNDECIDED, ALLOWED, or DENIED */
    globalStatus: FetchDomainGlobalStatus;
}
export declare const FetchDomain: {
    $type: "devvit.dev_portal.fetch_domain.FetchDomain";
    encode(message: FetchDomain, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): FetchDomain;
    fromJSON(object: any): FetchDomain;
    toJSON(message: FetchDomain): unknown;
    create(base?: DeepPartial<FetchDomain>): FetchDomain;
    fromPartial(object: DeepPartial<FetchDomain>): FetchDomain;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=fetch_domain.d.ts.map