/**
 * #installation_settings.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { SettingsValues } from "../../plugin/settings/v1alpha/settings.js";
import { Form } from "../../ui/form_builder/v1alpha/form.js";
export interface GetInstallationSettingsFormRequest {
    installationId: string;
}
export interface GetInstallationSettingsFormResponse {
    /** Installation settings Forms mapped by actor_name */
    form: {
        [key: string]: Form;
    };
}
export interface GetInstallationSettingsFormResponse_FormEntry {
    key: string;
    value?: Form | undefined;
}
export interface ValidateInstallationSettingsFormRequest {
    installationId: string;
    settings?: SettingsValues | undefined;
}
export interface ValidateInstallationSettingsFormResponse {
    /** If false, prevent submission and display errors on the form */
    success: boolean;
    /** Map of field_id:error pairs to display on the form */
    errors: {
        [key: string]: string;
    };
}
export interface ValidateInstallationSettingsFormResponse_ErrorsEntry {
    key: string;
    value: string;
}
export interface GetInstallationSettingsRequest {
    installationId: string;
}
export interface GetInstallationSettingsResponse {
    settings?: SettingsValues | undefined;
}
export interface UpdateInstallationSettingsRequest {
    installationId: string;
    settings?: SettingsValues | undefined;
}
export interface UpdateInstallationSettingsResponse {
    /** If false, prevent submission and display errors on the form */
    success: boolean;
    /** Map of field_id:error pairs to display on the form */
    errors: {
        [key: string]: string;
    };
}
export interface UpdateInstallationSettingsResponse_ErrorsEntry {
    key: string;
    value: string;
}
export declare const GetInstallationSettingsFormRequest: {
    $type: "devvit.dev_portal.installation_settings.GetInstallationSettingsFormRequest";
    encode(message: GetInstallationSettingsFormRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetInstallationSettingsFormRequest;
    fromJSON(object: any): GetInstallationSettingsFormRequest;
    toJSON(message: GetInstallationSettingsFormRequest): unknown;
    create(base?: DeepPartial<GetInstallationSettingsFormRequest>): GetInstallationSettingsFormRequest;
    fromPartial(object: DeepPartial<GetInstallationSettingsFormRequest>): GetInstallationSettingsFormRequest;
};
export declare const GetInstallationSettingsFormResponse: {
    $type: "devvit.dev_portal.installation_settings.GetInstallationSettingsFormResponse";
    encode(message: GetInstallationSettingsFormResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetInstallationSettingsFormResponse;
    fromJSON(object: any): GetInstallationSettingsFormResponse;
    toJSON(message: GetInstallationSettingsFormResponse): unknown;
    create(base?: DeepPartial<GetInstallationSettingsFormResponse>): GetInstallationSettingsFormResponse;
    fromPartial(object: DeepPartial<GetInstallationSettingsFormResponse>): GetInstallationSettingsFormResponse;
};
export declare const GetInstallationSettingsFormResponse_FormEntry: {
    $type: "devvit.dev_portal.installation_settings.GetInstallationSettingsFormResponse.FormEntry";
    encode(message: GetInstallationSettingsFormResponse_FormEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetInstallationSettingsFormResponse_FormEntry;
    fromJSON(object: any): GetInstallationSettingsFormResponse_FormEntry;
    toJSON(message: GetInstallationSettingsFormResponse_FormEntry): unknown;
    create(base?: DeepPartial<GetInstallationSettingsFormResponse_FormEntry>): GetInstallationSettingsFormResponse_FormEntry;
    fromPartial(object: DeepPartial<GetInstallationSettingsFormResponse_FormEntry>): GetInstallationSettingsFormResponse_FormEntry;
};
export declare const ValidateInstallationSettingsFormRequest: {
    $type: "devvit.dev_portal.installation_settings.ValidateInstallationSettingsFormRequest";
    encode(message: ValidateInstallationSettingsFormRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidateInstallationSettingsFormRequest;
    fromJSON(object: any): ValidateInstallationSettingsFormRequest;
    toJSON(message: ValidateInstallationSettingsFormRequest): unknown;
    create(base?: DeepPartial<ValidateInstallationSettingsFormRequest>): ValidateInstallationSettingsFormRequest;
    fromPartial(object: DeepPartial<ValidateInstallationSettingsFormRequest>): ValidateInstallationSettingsFormRequest;
};
export declare const ValidateInstallationSettingsFormResponse: {
    $type: "devvit.dev_portal.installation_settings.ValidateInstallationSettingsFormResponse";
    encode(message: ValidateInstallationSettingsFormResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidateInstallationSettingsFormResponse;
    fromJSON(object: any): ValidateInstallationSettingsFormResponse;
    toJSON(message: ValidateInstallationSettingsFormResponse): unknown;
    create(base?: DeepPartial<ValidateInstallationSettingsFormResponse>): ValidateInstallationSettingsFormResponse;
    fromPartial(object: DeepPartial<ValidateInstallationSettingsFormResponse>): ValidateInstallationSettingsFormResponse;
};
export declare const ValidateInstallationSettingsFormResponse_ErrorsEntry: {
    $type: "devvit.dev_portal.installation_settings.ValidateInstallationSettingsFormResponse.ErrorsEntry";
    encode(message: ValidateInstallationSettingsFormResponse_ErrorsEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidateInstallationSettingsFormResponse_ErrorsEntry;
    fromJSON(object: any): ValidateInstallationSettingsFormResponse_ErrorsEntry;
    toJSON(message: ValidateInstallationSettingsFormResponse_ErrorsEntry): unknown;
    create(base?: DeepPartial<ValidateInstallationSettingsFormResponse_ErrorsEntry>): ValidateInstallationSettingsFormResponse_ErrorsEntry;
    fromPartial(object: DeepPartial<ValidateInstallationSettingsFormResponse_ErrorsEntry>): ValidateInstallationSettingsFormResponse_ErrorsEntry;
};
export declare const GetInstallationSettingsRequest: {
    $type: "devvit.dev_portal.installation_settings.GetInstallationSettingsRequest";
    encode(message: GetInstallationSettingsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetInstallationSettingsRequest;
    fromJSON(object: any): GetInstallationSettingsRequest;
    toJSON(message: GetInstallationSettingsRequest): unknown;
    create(base?: DeepPartial<GetInstallationSettingsRequest>): GetInstallationSettingsRequest;
    fromPartial(object: DeepPartial<GetInstallationSettingsRequest>): GetInstallationSettingsRequest;
};
export declare const GetInstallationSettingsResponse: {
    $type: "devvit.dev_portal.installation_settings.GetInstallationSettingsResponse";
    encode(message: GetInstallationSettingsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetInstallationSettingsResponse;
    fromJSON(object: any): GetInstallationSettingsResponse;
    toJSON(message: GetInstallationSettingsResponse): unknown;
    create(base?: DeepPartial<GetInstallationSettingsResponse>): GetInstallationSettingsResponse;
    fromPartial(object: DeepPartial<GetInstallationSettingsResponse>): GetInstallationSettingsResponse;
};
export declare const UpdateInstallationSettingsRequest: {
    $type: "devvit.dev_portal.installation_settings.UpdateInstallationSettingsRequest";
    encode(message: UpdateInstallationSettingsRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateInstallationSettingsRequest;
    fromJSON(object: any): UpdateInstallationSettingsRequest;
    toJSON(message: UpdateInstallationSettingsRequest): unknown;
    create(base?: DeepPartial<UpdateInstallationSettingsRequest>): UpdateInstallationSettingsRequest;
    fromPartial(object: DeepPartial<UpdateInstallationSettingsRequest>): UpdateInstallationSettingsRequest;
};
export declare const UpdateInstallationSettingsResponse: {
    $type: "devvit.dev_portal.installation_settings.UpdateInstallationSettingsResponse";
    encode(message: UpdateInstallationSettingsResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateInstallationSettingsResponse;
    fromJSON(object: any): UpdateInstallationSettingsResponse;
    toJSON(message: UpdateInstallationSettingsResponse): unknown;
    create(base?: DeepPartial<UpdateInstallationSettingsResponse>): UpdateInstallationSettingsResponse;
    fromPartial(object: DeepPartial<UpdateInstallationSettingsResponse>): UpdateInstallationSettingsResponse;
};
export declare const UpdateInstallationSettingsResponse_ErrorsEntry: {
    $type: "devvit.dev_portal.installation_settings.UpdateInstallationSettingsResponse.ErrorsEntry";
    encode(message: UpdateInstallationSettingsResponse_ErrorsEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateInstallationSettingsResponse_ErrorsEntry;
    fromJSON(object: any): UpdateInstallationSettingsResponse_ErrorsEntry;
    toJSON(message: UpdateInstallationSettingsResponse_ErrorsEntry): unknown;
    create(base?: DeepPartial<UpdateInstallationSettingsResponse_ErrorsEntry>): UpdateInstallationSettingsResponse_ErrorsEntry;
    fromPartial(object: DeepPartial<UpdateInstallationSettingsResponse_ErrorsEntry>): UpdateInstallationSettingsResponse_ErrorsEntry;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=installation_settings.d.ts.map