/**
 * #admin.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { Metadata } from "../../../../../../../lib/Types.js";
import { CreateDataTokenResponse, GetDataTokenByIdRequest, GetDataTokenByIdResponse, GetDataTokensByOrganizationNameRequest, GetDataTokensByOrganizationNameResponse } from "../../../../data_api/admin/auth/auth.js";
import { GetOrganizationByNameRequest, GetOrganizationByNameResponse } from "../../../../data_api/admin/organization/organization.js";
import { GetDataSubscriptionByIdRequest, GetDataSubscriptionByIdResponse } from "../../../../data_api/admin/subscription/subscription.js";
import { CreateFirehoseMonitorDataTokenRequest, GetFirehoseMonitorSubscriptionByNameRequest, GetFirehoseMonitorSubscriptionByNameResponse } from "./firehose_monitor.js";
/** This is an internal service used for managing data tokens and subscriptions */
export interface InternalDataApiAdmin {
    /** Data Token */
    GetDataTokenById(request: GetDataTokenByIdRequest, metadata?: Metadata): Promise<GetDataTokenByIdResponse>;
    GetDataTokensByOrganizationName(request: GetDataTokensByOrganizationNameRequest, metadata?: Metadata): Promise<GetDataTokensByOrganizationNameResponse>;
    /** Subscriptions */
    GetDataSubscriptionById(request: GetDataSubscriptionByIdRequest, metadata?: Metadata): Promise<GetDataSubscriptionByIdResponse>;
    /** Firehose monitor utils */
    CreateFirehoseMonitorDataToken(request: CreateFirehoseMonitorDataTokenRequest, metadata?: Metadata): Promise<CreateDataTokenResponse>;
    GetFirehoseMonitorSubscriptionByName(request: GetFirehoseMonitorSubscriptionByNameRequest, metadata?: Metadata): Promise<GetFirehoseMonitorSubscriptionByNameResponse>;
    GetOrganizationByName(request: GetOrganizationByNameRequest, metadata?: Metadata): Promise<GetOrganizationByNameResponse>;
}
export declare const InternalDataApiAdminServiceName = "devvit.dev_portal.internal.data_api.v1alpha.admin.InternalDataApiAdmin";
export declare class InternalDataApiAdminClientImpl implements InternalDataApiAdmin {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    GetDataTokenById(request: GetDataTokenByIdRequest, metadata?: Metadata): Promise<GetDataTokenByIdResponse>;
    GetDataTokensByOrganizationName(request: GetDataTokensByOrganizationNameRequest, metadata?: Metadata): Promise<GetDataTokensByOrganizationNameResponse>;
    GetDataSubscriptionById(request: GetDataSubscriptionByIdRequest, metadata?: Metadata): Promise<GetDataSubscriptionByIdResponse>;
    CreateFirehoseMonitorDataToken(request: CreateFirehoseMonitorDataTokenRequest, metadata?: Metadata): Promise<CreateDataTokenResponse>;
    GetFirehoseMonitorSubscriptionByName(request: GetFirehoseMonitorSubscriptionByNameRequest, metadata?: Metadata): Promise<GetFirehoseMonitorSubscriptionByNameResponse>;
    GetOrganizationByName(request: GetOrganizationByNameRequest, metadata?: Metadata): Promise<GetOrganizationByNameResponse>;
}
/** This is an internal service used for managing data tokens and subscriptions */
export type InternalDataApiAdminDefinition = typeof InternalDataApiAdminDefinition;
export declare const InternalDataApiAdminDefinition: {
    readonly name: "InternalDataApiAdmin";
    readonly fullName: "devvit.dev_portal.internal.data_api.v1alpha.admin.InternalDataApiAdmin";
    readonly methods: {
        /** Data Token */
        readonly getDataTokenById: {
            readonly name: "GetDataTokenById";
            readonly requestType: {
                $type: "devvit.dev_portal.data_api.admin.auth.GetDataTokenByIdRequest";
                encode(message: GetDataTokenByIdRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetDataTokenByIdRequest;
                fromJSON(object: any): GetDataTokenByIdRequest;
                toJSON(message: GetDataTokenByIdRequest): unknown;
                create(base?: {
                    id?: string;
                }): GetDataTokenByIdRequest;
                fromPartial(object: {
                    id?: string;
                }): GetDataTokenByIdRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.dev_portal.data_api.admin.auth.GetDataTokenByIdResponse";
                encode(message: GetDataTokenByIdResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetDataTokenByIdResponse;
                fromJSON(object: any): GetDataTokenByIdResponse;
                toJSON(message: GetDataTokenByIdResponse): unknown;
                create(base?: {
                    token?: {
                        id?: string;
                        organizationId?: string;
                        createdAt?: Date | undefined;
                        expiresAt?: Date | undefined;
                        isRevoked?: boolean;
                    } | undefined;
                }): GetDataTokenByIdResponse;
                fromPartial(object: {
                    token?: {
                        id?: string;
                        organizationId?: string;
                        createdAt?: Date | undefined;
                        expiresAt?: Date | undefined;
                        isRevoked?: boolean;
                    } | undefined;
                }): GetDataTokenByIdResponse;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        readonly getDataTokensByOrganizationName: {
            readonly name: "GetDataTokensByOrganizationName";
            readonly requestType: {
                $type: "devvit.dev_portal.data_api.admin.auth.GetDataTokensByOrganizationNameRequest";
                encode(message: GetDataTokensByOrganizationNameRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetDataTokensByOrganizationNameRequest;
                fromJSON(object: any): GetDataTokensByOrganizationNameRequest;
                toJSON(message: GetDataTokensByOrganizationNameRequest): unknown;
                create(base?: {
                    organizationName?: string;
                }): GetDataTokensByOrganizationNameRequest;
                fromPartial(object: {
                    organizationName?: string;
                }): GetDataTokensByOrganizationNameRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.dev_portal.data_api.admin.auth.GetDataTokensByOrganizationNameResponse";
                encode(message: GetDataTokensByOrganizationNameResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetDataTokensByOrganizationNameResponse;
                fromJSON(object: any): GetDataTokensByOrganizationNameResponse;
                toJSON(message: GetDataTokensByOrganizationNameResponse): unknown;
                create(base?: {
                    tokens?: {
                        id?: string;
                        organizationId?: string;
                        createdAt?: Date | undefined;
                        expiresAt?: Date | undefined;
                        isRevoked?: boolean;
                    }[];
                }): GetDataTokensByOrganizationNameResponse;
                fromPartial(object: {
                    tokens?: {
                        id?: string;
                        organizationId?: string;
                        createdAt?: Date | undefined;
                        expiresAt?: Date | undefined;
                        isRevoked?: boolean;
                    }[];
                }): GetDataTokensByOrganizationNameResponse;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        /** Subscriptions */
        readonly getDataSubscriptionById: {
            readonly name: "GetDataSubscriptionById";
            readonly requestType: {
                $type: "devvit.dev_portal.data_api.admin.subscription.GetDataSubscriptionByIdRequest";
                encode(message: GetDataSubscriptionByIdRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetDataSubscriptionByIdRequest;
                fromJSON(object: any): GetDataSubscriptionByIdRequest;
                toJSON(message: GetDataSubscriptionByIdRequest): unknown;
                create(base?: {
                    subscriptionId?: string;
                }): GetDataSubscriptionByIdRequest;
                fromPartial(object: {
                    subscriptionId?: string;
                }): GetDataSubscriptionByIdRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.dev_portal.data_api.admin.subscription.GetDataSubscriptionByIdResponse";
                encode(message: GetDataSubscriptionByIdResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetDataSubscriptionByIdResponse;
                fromJSON(object: any): GetDataSubscriptionByIdResponse;
                toJSON(message: GetDataSubscriptionByIdResponse): unknown;
                create(base?: {
                    subscription?: {
                        id?: string;
                        tier?: import("../../../../../options/options.js").DataTier;
                        events?: import("../../../../../options/options.js").FirehoseEvent[];
                        subreddits?: string[];
                        subredditRatings?: import("../../../../../reddit/v2alpha/subredditv2.js").SubredditRating[];
                        organizationId?: string;
                        name?: string;
                        description?: string | undefined | undefined;
                    } | undefined;
                }): GetDataSubscriptionByIdResponse;
                fromPartial(object: {
                    subscription?: {
                        id?: string;
                        tier?: import("../../../../../options/options.js").DataTier;
                        events?: import("../../../../../options/options.js").FirehoseEvent[];
                        subreddits?: string[];
                        subredditRatings?: import("../../../../../reddit/v2alpha/subredditv2.js").SubredditRating[];
                        organizationId?: string;
                        name?: string;
                        description?: string | undefined | undefined;
                    } | undefined;
                }): GetDataSubscriptionByIdResponse;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        /** Firehose monitor utils */
        readonly createFirehoseMonitorDataToken: {
            readonly name: "CreateFirehoseMonitorDataToken";
            readonly requestType: {
                $type: "devvit.dev_portal.internal.data_api.v1alpha.admin.CreateFirehoseMonitorDataTokenRequest";
                encode(message: CreateFirehoseMonitorDataTokenRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): CreateFirehoseMonitorDataTokenRequest;
                fromJSON(object: any): CreateFirehoseMonitorDataTokenRequest;
                toJSON(message: CreateFirehoseMonitorDataTokenRequest): unknown;
                create(base?: {
                    expiresIn?: {
                        seconds?: number;
                        nanos?: number;
                    } | undefined;
                }): CreateFirehoseMonitorDataTokenRequest;
                fromPartial(object: {
                    expiresIn?: {
                        seconds?: number;
                        nanos?: number;
                    } | undefined;
                }): CreateFirehoseMonitorDataTokenRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.dev_portal.data_api.admin.auth.CreateDataTokenResponse";
                encode(message: CreateDataTokenResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): CreateDataTokenResponse;
                fromJSON(object: any): CreateDataTokenResponse;
                toJSON(message: CreateDataTokenResponse): unknown;
                create(base?: {
                    token?: string;
                    expiresAt?: Date | undefined;
                }): CreateDataTokenResponse;
                fromPartial(object: {
                    token?: string;
                    expiresAt?: Date | undefined;
                }): CreateDataTokenResponse;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        readonly getFirehoseMonitorSubscriptionByName: {
            readonly name: "GetFirehoseMonitorSubscriptionByName";
            readonly requestType: {
                $type: "devvit.dev_portal.internal.data_api.v1alpha.admin.GetFirehoseMonitorSubscriptionByNameRequest";
                encode(message: GetFirehoseMonitorSubscriptionByNameRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetFirehoseMonitorSubscriptionByNameRequest;
                fromJSON(object: any): GetFirehoseMonitorSubscriptionByNameRequest;
                toJSON(message: GetFirehoseMonitorSubscriptionByNameRequest): unknown;
                create(base?: {
                    name?: string;
                }): GetFirehoseMonitorSubscriptionByNameRequest;
                fromPartial(object: {
                    name?: string;
                }): GetFirehoseMonitorSubscriptionByNameRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.dev_portal.internal.data_api.v1alpha.admin.GetFirehoseMonitorSubscriptionByNameResponse";
                encode(message: GetFirehoseMonitorSubscriptionByNameResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetFirehoseMonitorSubscriptionByNameResponse;
                fromJSON(object: any): GetFirehoseMonitorSubscriptionByNameResponse;
                toJSON(message: GetFirehoseMonitorSubscriptionByNameResponse): unknown;
                create(base?: {
                    id?: string;
                }): GetFirehoseMonitorSubscriptionByNameResponse;
                fromPartial(object: {
                    id?: string;
                }): GetFirehoseMonitorSubscriptionByNameResponse;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        readonly getOrganizationByName: {
            readonly name: "GetOrganizationByName";
            readonly requestType: {
                $type: "devvit.dev_portal.data_api.admin.organization.GetOrganizationByNameRequest";
                encode(message: GetOrganizationByNameRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetOrganizationByNameRequest;
                fromJSON(object: any): GetOrganizationByNameRequest;
                toJSON(message: GetOrganizationByNameRequest): unknown;
                create(base?: {
                    name?: string;
                }): GetOrganizationByNameRequest;
                fromPartial(object: {
                    name?: string;
                }): GetOrganizationByNameRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.dev_portal.data_api.admin.organization.GetOrganizationByNameResponse";
                encode(message: GetOrganizationByNameResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetOrganizationByNameResponse;
                fromJSON(object: any): GetOrganizationByNameResponse;
                toJSON(message: GetOrganizationByNameResponse): unknown;
                create(base?: {
                    organizationId?: string;
                    isInternal?: boolean;
                }): GetOrganizationByNameResponse;
                fromPartial(object: {
                    organizationId?: string;
                    isInternal?: boolean;
                }): GetOrganizationByNameResponse;
            };
            readonly responseStream: false;
            readonly options: {};
        };
    };
};
interface Rpc {
    request(service: string, method: string, data: Uint8Array, metadata?: Metadata): Promise<Uint8Array>;
}
export {};
//# sourceMappingURL=admin.d.ts.map