import { GetDataTokenByIdRequest, GetDataTokenByIdResponse, GetDataTokensByOrganizationNameRequest, GetDataTokensByOrganizationNameResponse, CreateDataTokenResponse } from '../../../../data_api/admin/auth/auth.js';
import { GetDataSubscriptionByIdRequest, GetDataSubscriptionByIdResponse } from '../../../../data_api/admin/subscription/subscription.js';
import { CreateFirehoseMonitorDataTokenRequest, GetFirehoseMonitorSubscriptionByNameRequest, GetFirehoseMonitorSubscriptionByNameResponse } from './firehose_monitor.js';
import { GetOrganizationByNameRequest, GetOrganizationByNameResponse } from '../../../../data_api/admin/organization/organization.js';
interface Rpc {
    request(service: string, method: string, contentType: 'application/json' | 'application/protobuf', data: object | Uint8Array): Promise<object | Uint8Array>;
}
export interface InternalDataApiAdminClient {
    GetDataTokenById(request: GetDataTokenByIdRequest): Promise<GetDataTokenByIdResponse>;
    GetDataTokensByOrganizationName(request: GetDataTokensByOrganizationNameRequest): Promise<GetDataTokensByOrganizationNameResponse>;
    GetDataSubscriptionById(request: GetDataSubscriptionByIdRequest): Promise<GetDataSubscriptionByIdResponse>;
    CreateFirehoseMonitorDataToken(request: CreateFirehoseMonitorDataTokenRequest): Promise<CreateDataTokenResponse>;
    GetFirehoseMonitorSubscriptionByName(request: GetFirehoseMonitorSubscriptionByNameRequest): Promise<GetFirehoseMonitorSubscriptionByNameResponse>;
    GetOrganizationByName(request: GetOrganizationByNameRequest): Promise<GetOrganizationByNameResponse>;
}
export declare class InternalDataApiAdminClientJSON implements InternalDataApiAdminClient {
    private readonly rpc;
    constructor(rpc: Rpc);
    GetDataTokenById(request: GetDataTokenByIdRequest): Promise<GetDataTokenByIdResponse>;
    GetDataTokensByOrganizationName(request: GetDataTokensByOrganizationNameRequest): Promise<GetDataTokensByOrganizationNameResponse>;
    GetDataSubscriptionById(request: GetDataSubscriptionByIdRequest): Promise<GetDataSubscriptionByIdResponse>;
    CreateFirehoseMonitorDataToken(request: CreateFirehoseMonitorDataTokenRequest): Promise<CreateDataTokenResponse>;
    GetFirehoseMonitorSubscriptionByName(request: GetFirehoseMonitorSubscriptionByNameRequest): Promise<GetFirehoseMonitorSubscriptionByNameResponse>;
    GetOrganizationByName(request: GetOrganizationByNameRequest): Promise<GetOrganizationByNameResponse>;
}
export declare class InternalDataApiAdminClientProtobuf implements InternalDataApiAdminClient {
    private readonly rpc;
    constructor(rpc: Rpc);
    GetDataTokenById(request: GetDataTokenByIdRequest): Promise<GetDataTokenByIdResponse>;
    GetDataTokensByOrganizationName(request: GetDataTokensByOrganizationNameRequest): Promise<GetDataTokensByOrganizationNameResponse>;
    GetDataSubscriptionById(request: GetDataSubscriptionByIdRequest): Promise<GetDataSubscriptionByIdResponse>;
    CreateFirehoseMonitorDataToken(request: CreateFirehoseMonitorDataTokenRequest): Promise<CreateDataTokenResponse>;
    GetFirehoseMonitorSubscriptionByName(request: GetFirehoseMonitorSubscriptionByNameRequest): Promise<GetFirehoseMonitorSubscriptionByNameResponse>;
    GetOrganizationByName(request: GetOrganizationByNameRequest): Promise<GetOrganizationByNameResponse>;
}
export {};
//# sourceMappingURL=admin.twirp-client.d.ts.map