import { TwirpContext, TwirpServer } from 'twirp-ts';
import { GetDataTokenByIdRequest, GetDataTokenByIdResponse, GetDataTokensByOrganizationNameRequest, GetDataTokensByOrganizationNameResponse, CreateDataTokenResponse } from '../../../../data_api/admin/auth/auth.js';
import { GetDataSubscriptionByIdRequest, GetDataSubscriptionByIdResponse } from '../../../../data_api/admin/subscription/subscription.js';
import { CreateFirehoseMonitorDataTokenRequest, GetFirehoseMonitorSubscriptionByNameRequest, GetFirehoseMonitorSubscriptionByNameResponse } from './firehose_monitor.js';
import { GetOrganizationByNameRequest, GetOrganizationByNameResponse } from '../../../../data_api/admin/organization/organization.js';
export interface InternalDataApiAdminTwirp<T extends TwirpContext = TwirpContext> {
    GetDataTokenById(ctx: T, request: GetDataTokenByIdRequest): Promise<GetDataTokenByIdResponse>;
    GetDataTokensByOrganizationName(ctx: T, request: GetDataTokensByOrganizationNameRequest): Promise<GetDataTokensByOrganizationNameResponse>;
    GetDataSubscriptionById(ctx: T, request: GetDataSubscriptionByIdRequest): Promise<GetDataSubscriptionByIdResponse>;
    CreateFirehoseMonitorDataToken(ctx: T, request: CreateFirehoseMonitorDataTokenRequest): Promise<CreateDataTokenResponse>;
    GetFirehoseMonitorSubscriptionByName(ctx: T, request: GetFirehoseMonitorSubscriptionByNameRequest): Promise<GetFirehoseMonitorSubscriptionByNameResponse>;
    GetOrganizationByName(ctx: T, request: GetOrganizationByNameRequest): Promise<GetOrganizationByNameResponse>;
}
export declare enum InternalDataApiAdminMethod {
    GetDataTokenById = "GetDataTokenById",
    GetDataTokensByOrganizationName = "GetDataTokensByOrganizationName",
    GetDataSubscriptionById = "GetDataSubscriptionById",
    CreateFirehoseMonitorDataToken = "CreateFirehoseMonitorDataToken",
    GetFirehoseMonitorSubscriptionByName = "GetFirehoseMonitorSubscriptionByName",
    GetOrganizationByName = "GetOrganizationByName"
}
export declare const InternalDataApiAdminMethodList: InternalDataApiAdminMethod[];
export declare function createInternalDataApiAdminServer<T extends TwirpContext = TwirpContext>(service: InternalDataApiAdminTwirp<T>): TwirpServer<InternalDataApiAdminTwirp<TwirpContext<import("http").IncomingMessage, import("http").ServerResponse<import("http").IncomingMessage>>>, T>;
//# sourceMappingURL=admin.twirp.d.ts.map