/**
 * #media.ts
 *
 * @packageDocumentation
 */
/* eslint-disable */
import _m0 from "protobufjs/minimal.js";
import { Empty } from "../../../../google/protobuf/empty.js";
import { messageTypeRegistry } from "../../../../typeRegistry.js";
export var AssetStatus;
(function (AssetStatus) {
    AssetStatus[AssetStatus["MISSING"] = 0] = "MISSING";
    AssetStatus[AssetStatus["PROCESSING"] = 1] = "PROCESSING";
    AssetStatus[AssetStatus["READY"] = 2] = "READY";
    AssetStatus[AssetStatus["REJECTED"] = 3] = "REJECTED";
    AssetStatus[AssetStatus["ERROR"] = 4] = "ERROR";
    AssetStatus[AssetStatus["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(AssetStatus || (AssetStatus = {}));
export function assetStatusFromJSON(object) {
    switch (object) {
        case 0:
        case "MISSING":
            return AssetStatus.MISSING;
        case 1:
        case "PROCESSING":
            return AssetStatus.PROCESSING;
        case 2:
        case "READY":
            return AssetStatus.READY;
        case 3:
        case "REJECTED":
            return AssetStatus.REJECTED;
        case 4:
        case "ERROR":
            return AssetStatus.ERROR;
        case -1:
        case "UNRECOGNIZED":
        default:
            return AssetStatus.UNRECOGNIZED;
    }
}
export function assetStatusToJSON(object) {
    switch (object) {
        case AssetStatus.MISSING:
            return 0;
        case AssetStatus.PROCESSING:
            return 1;
        case AssetStatus.READY:
            return 2;
        case AssetStatus.REJECTED:
            return 3;
        case AssetStatus.ERROR:
            return 4;
        case AssetStatus.UNRECOGNIZED:
        default:
            return -1;
    }
}
function createBaseUpdateAssetStatusRequest() {
    return { mediaId: "", newStatus: 0, url: "" };
}
export const UpdateAssetStatusRequest = {
    $type: "devvit.dev_portal.internal.media.UpdateAssetStatusRequest",
    encode(message, writer = _m0.Writer.create()) {
        if (message.mediaId !== "") {
            writer.uint32(10).string(message.mediaId);
        }
        if (message.newStatus !== 0) {
            writer.uint32(16).int32(message.newStatus);
        }
        if (message.url !== "") {
            writer.uint32(26).string(message.url);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateAssetStatusRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 10) {
                        break;
                    }
                    message.mediaId = reader.string();
                    continue;
                case 2:
                    if (tag !== 16) {
                        break;
                    }
                    message.newStatus = reader.int32();
                    continue;
                case 3:
                    if (tag !== 26) {
                        break;
                    }
                    message.url = reader.string();
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            mediaId: isSet(object.mediaId) ? globalThis.String(object.mediaId) : "",
            newStatus: isSet(object.newStatus) ? assetStatusFromJSON(object.newStatus) : 0,
            url: isSet(object.url) ? globalThis.String(object.url) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.mediaId !== "") {
            obj.mediaId = message.mediaId;
        }
        if (message.newStatus !== 0) {
            obj.newStatus = assetStatusToJSON(message.newStatus);
        }
        if (message.url !== "") {
            obj.url = message.url;
        }
        return obj;
    },
    create(base) {
        return UpdateAssetStatusRequest.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseUpdateAssetStatusRequest();
        message.mediaId = object.mediaId ?? "";
        message.newStatus = object.newStatus ?? 0;
        message.url = object.url ?? "";
        return message;
    },
};
messageTypeRegistry.set(UpdateAssetStatusRequest.$type, UpdateAssetStatusRequest);
function createBaseUpdateAssetStatusResponse() {
    return {};
}
export const UpdateAssetStatusResponse = {
    $type: "devvit.dev_portal.internal.media.UpdateAssetStatusResponse",
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateAssetStatusResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    create(base) {
        return UpdateAssetStatusResponse.fromPartial(base ?? {});
    },
    fromPartial(_) {
        const message = createBaseUpdateAssetStatusResponse();
        return message;
    },
};
messageTypeRegistry.set(UpdateAssetStatusResponse.$type, UpdateAssetStatusResponse);
function createBaseCheckForV1AssetAndBackfillRequest() {
    return { appId: "", appVersionNumber: "", assetPath: "" };
}
export const CheckForV1AssetAndBackfillRequest = {
    $type: "devvit.dev_portal.internal.media.CheckForV1AssetAndBackfillRequest",
    encode(message, writer = _m0.Writer.create()) {
        if (message.appId !== "") {
            writer.uint32(10).string(message.appId);
        }
        if (message.appVersionNumber !== "") {
            writer.uint32(18).string(message.appVersionNumber);
        }
        if (message.assetPath !== "") {
            writer.uint32(26).string(message.assetPath);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCheckForV1AssetAndBackfillRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 10) {
                        break;
                    }
                    message.appId = reader.string();
                    continue;
                case 2:
                    if (tag !== 18) {
                        break;
                    }
                    message.appVersionNumber = reader.string();
                    continue;
                case 3:
                    if (tag !== 26) {
                        break;
                    }
                    message.assetPath = reader.string();
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            appId: isSet(object.appId) ? globalThis.String(object.appId) : "",
            appVersionNumber: isSet(object.appVersionNumber) ? globalThis.String(object.appVersionNumber) : "",
            assetPath: isSet(object.assetPath) ? globalThis.String(object.assetPath) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.appId !== "") {
            obj.appId = message.appId;
        }
        if (message.appVersionNumber !== "") {
            obj.appVersionNumber = message.appVersionNumber;
        }
        if (message.assetPath !== "") {
            obj.assetPath = message.assetPath;
        }
        return obj;
    },
    create(base) {
        return CheckForV1AssetAndBackfillRequest.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseCheckForV1AssetAndBackfillRequest();
        message.appId = object.appId ?? "";
        message.appVersionNumber = object.appVersionNumber ?? "";
        message.assetPath = object.assetPath ?? "";
        return message;
    },
};
messageTypeRegistry.set(CheckForV1AssetAndBackfillRequest.$type, CheckForV1AssetAndBackfillRequest);
export const DevPortalMediaServiceName = "devvit.dev_portal.internal.media.DevPortalMedia";
export class DevPortalMediaClientImpl {
    constructor(rpc, opts) {
        this.service = opts?.service || DevPortalMediaServiceName;
        this.rpc = rpc;
        this.UpdateAssetStatus = this.UpdateAssetStatus.bind(this);
        this.CheckForV1AssetAndBackfill = this.CheckForV1AssetAndBackfill.bind(this);
    }
    UpdateAssetStatus(request, metadata) {
        const data = UpdateAssetStatusRequest.encode(request).finish();
        const promise = this.rpc.request(this.service, "UpdateAssetStatus", data, metadata);
        return promise.then((data) => UpdateAssetStatusResponse.decode(_m0.Reader.create(data)));
    }
    CheckForV1AssetAndBackfill(request, metadata) {
        const data = CheckForV1AssetAndBackfillRequest.encode(request).finish();
        const promise = this.rpc.request(this.service, "CheckForV1AssetAndBackfill", data, metadata);
        return promise.then((data) => Empty.decode(_m0.Reader.create(data)));
    }
}
export const DevPortalMediaDefinition = {
    name: "DevPortalMedia",
    fullName: "devvit.dev_portal.internal.media.DevPortalMedia",
    methods: {
        /** Updates a media asset's status, if it's an asset dev-portal cares about */
        updateAssetStatus: {
            name: "UpdateAssetStatus",
            requestType: UpdateAssetStatusRequest,
            requestStream: false,
            responseType: UpdateAssetStatusResponse,
            responseStream: false,
            options: {},
        },
        checkForV1AssetAndBackfill: {
            name: "CheckForV1AssetAndBackfill",
            requestType: CheckForV1AssetAndBackfillRequest,
            requestStream: false,
            responseType: Empty,
            responseStream: false,
            options: {},
        },
    },
};
function isSet(value) {
    return value !== null && value !== undefined;
}
