/**
 * #payments_verification.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
/**
 * The verification status of a devvit developer. This shows whether or not a user can receive payments
 * and their state in the verification flow. See design doc here:
 * https://docs.google.com/document/d/1HuAfNB_26jnNu7gGDHk-vafzgpnoNaFqHoumE2C40cA/edit?tab=t.0#bookmark=id.hm6xb18pqjvh
 */
export declare enum PaymentsVerificationStatus {
    UNKNOWN = 0,
    /** VERIFICATION_NOT_STARTED - User has not begun the verification process and is permitted to. */
    VERIFICATION_NOT_STARTED = 1,
    /** VERIFICATION_PENDING - User has begun the verification process. */
    VERIFICATION_PENDING = 2,
    /**
     * VERIFICATION_CAN_NOT_START - User is not eligible to receive payments. This may be because they're ineligible to apply for payments
     * or because they applied and were rejected.
     */
    VERIFICATION_CAN_NOT_START = 3,
    /** VERIFICATION_SUCCESS - Verification has been completed and the user is able to receive payments. */
    VERIFICATION_SUCCESS = 4,
    UNRECOGNIZED = -1
}
export declare function paymentsVerificationStatusFromJSON(object: any): PaymentsVerificationStatus;
export declare function paymentsVerificationStatusToJSON(object: PaymentsVerificationStatus): number;
/** Get verification status. */
export interface GetPaymentsVerificationStatusRequest {
}
/** Return verification response. */
export interface GetPaymentsVerificationStatusResponse {
    status: PaymentsVerificationStatus;
}
export declare const GetPaymentsVerificationStatusRequest: {
    $type: "devvit.dev_portal.payments.GetPaymentsVerificationStatusRequest";
    encode(_: GetPaymentsVerificationStatusRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetPaymentsVerificationStatusRequest;
    fromJSON(_: any): GetPaymentsVerificationStatusRequest;
    toJSON(_: GetPaymentsVerificationStatusRequest): unknown;
    create(base?: DeepPartial<GetPaymentsVerificationStatusRequest>): GetPaymentsVerificationStatusRequest;
    fromPartial(_: DeepPartial<GetPaymentsVerificationStatusRequest>): GetPaymentsVerificationStatusRequest;
};
export declare const GetPaymentsVerificationStatusResponse: {
    $type: "devvit.dev_portal.payments.GetPaymentsVerificationStatusResponse";
    encode(message: GetPaymentsVerificationStatusResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GetPaymentsVerificationStatusResponse;
    fromJSON(object: any): GetPaymentsVerificationStatusResponse;
    toJSON(message: GetPaymentsVerificationStatusResponse): unknown;
    create(base?: DeepPartial<GetPaymentsVerificationStatusResponse>): GetPaymentsVerificationStatusResponse;
    fromPartial(object: DeepPartial<GetPaymentsVerificationStatusResponse>): GetPaymentsVerificationStatusResponse;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=payments_verification.d.ts.map