/**
 * #waitlist.ts
 *
 * @packageDocumentation
 */
/* eslint-disable */
import _m0 from "protobufjs/minimal.js";
import { Empty } from "../../../google/protobuf/empty.js";
import { StringValue } from "../../../google/protobuf/wrappers.js";
import { messageTypeRegistry } from "../../../typeRegistry.js";
import { waitlistStatusFromJSON, waitlistStatusToJSON } from "../admin/waitlist_admin.js";
export var ProgrammingExperienceLevel;
(function (ProgrammingExperienceLevel) {
    ProgrammingExperienceLevel[ProgrammingExperienceLevel["BEGINNER"] = 0] = "BEGINNER";
    ProgrammingExperienceLevel[ProgrammingExperienceLevel["PROFICIENT"] = 1] = "PROFICIENT";
    ProgrammingExperienceLevel[ProgrammingExperienceLevel["EXPERT"] = 2] = "EXPERT";
    ProgrammingExperienceLevel[ProgrammingExperienceLevel["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(ProgrammingExperienceLevel || (ProgrammingExperienceLevel = {}));
export function programmingExperienceLevelFromJSON(object) {
    switch (object) {
        case 0:
        case "BEGINNER":
            return ProgrammingExperienceLevel.BEGINNER;
        case 1:
        case "PROFICIENT":
            return ProgrammingExperienceLevel.PROFICIENT;
        case 2:
        case "EXPERT":
            return ProgrammingExperienceLevel.EXPERT;
        case -1:
        case "UNRECOGNIZED":
        default:
            return ProgrammingExperienceLevel.UNRECOGNIZED;
    }
}
export function programmingExperienceLevelToJSON(object) {
    switch (object) {
        case ProgrammingExperienceLevel.BEGINNER:
            return 0;
        case ProgrammingExperienceLevel.PROFICIENT:
            return 1;
        case ProgrammingExperienceLevel.EXPERT:
            return 2;
        case ProgrammingExperienceLevel.UNRECOGNIZED:
        default:
            return -1;
    }
}
function createBaseIsCurrentUserRegisteredResponse() {
    return { isRegistered: false, response: undefined, waitlistStatus: 0 };
}
export const IsCurrentUserRegisteredResponse = {
    $type: "devvit.dev_portal.waitlist.IsCurrentUserRegisteredResponse",
    encode(message, writer = _m0.Writer.create()) {
        if (message.isRegistered !== false) {
            writer.uint32(8).bool(message.isRegistered);
        }
        if (message.response !== undefined) {
            WaitlistRegisterUserRequest.encode(message.response, writer.uint32(18).fork()).ldelim();
        }
        if (message.waitlistStatus !== 0) {
            writer.uint32(24).int32(message.waitlistStatus);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseIsCurrentUserRegisteredResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 8) {
                        break;
                    }
                    message.isRegistered = reader.bool();
                    continue;
                case 2:
                    if (tag !== 18) {
                        break;
                    }
                    message.response = WaitlistRegisterUserRequest.decode(reader, reader.uint32());
                    continue;
                case 3:
                    if (tag !== 24) {
                        break;
                    }
                    message.waitlistStatus = reader.int32();
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            isRegistered: isSet(object.isRegistered) ? globalThis.Boolean(object.isRegistered) : false,
            response: isSet(object.response) ? WaitlistRegisterUserRequest.fromJSON(object.response) : undefined,
            waitlistStatus: isSet(object.waitlistStatus) ? waitlistStatusFromJSON(object.waitlistStatus) : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.isRegistered !== false) {
            obj.isRegistered = message.isRegistered;
        }
        if (message.response !== undefined) {
            obj.response = WaitlistRegisterUserRequest.toJSON(message.response);
        }
        if (message.waitlistStatus !== 0) {
            obj.waitlistStatus = waitlistStatusToJSON(message.waitlistStatus);
        }
        return obj;
    },
    create(base) {
        return IsCurrentUserRegisteredResponse.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseIsCurrentUserRegisteredResponse();
        message.isRegistered = object.isRegistered ?? false;
        message.response = (object.response !== undefined && object.response !== null)
            ? WaitlistRegisterUserRequest.fromPartial(object.response)
            : undefined;
        message.waitlistStatus = object.waitlistStatus ?? 0;
        return message;
    },
};
messageTypeRegistry.set(IsCurrentUserRegisteredResponse.$type, IsCurrentUserRegisteredResponse);
function createBaseWaitlistRegisterUserRequest() {
    return {
        userId: "",
        userName: "",
        whatToBuild: "",
        botsBuilt: undefined,
        programmingExperience: {},
        appsWanted: "",
        doesConsentToEmail: false,
    };
}
export const WaitlistRegisterUserRequest = {
    $type: "devvit.dev_portal.waitlist.WaitlistRegisterUserRequest",
    encode(message, writer = _m0.Writer.create()) {
        if (message.userId !== "") {
            writer.uint32(10).string(message.userId);
        }
        if (message.userName !== "") {
            writer.uint32(18).string(message.userName);
        }
        if (message.whatToBuild !== "") {
            writer.uint32(26).string(message.whatToBuild);
        }
        if (message.botsBuilt !== undefined) {
            StringValue.encode({ value: message.botsBuilt }, writer.uint32(42).fork()).ldelim();
        }
        Object.entries(message.programmingExperience).forEach(([key, value]) => {
            WaitlistRegisterUserRequest_ProgrammingExperienceEntry.encode({ key: key, value }, writer.uint32(50).fork()).ldelim();
        });
        if (message.appsWanted !== "") {
            writer.uint32(58).string(message.appsWanted);
        }
        if (message.doesConsentToEmail !== false) {
            writer.uint32(64).bool(message.doesConsentToEmail);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseWaitlistRegisterUserRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 10) {
                        break;
                    }
                    message.userId = reader.string();
                    continue;
                case 2:
                    if (tag !== 18) {
                        break;
                    }
                    message.userName = reader.string();
                    continue;
                case 3:
                    if (tag !== 26) {
                        break;
                    }
                    message.whatToBuild = reader.string();
                    continue;
                case 5:
                    if (tag !== 42) {
                        break;
                    }
                    message.botsBuilt = StringValue.decode(reader, reader.uint32()).value;
                    continue;
                case 6:
                    if (tag !== 50) {
                        break;
                    }
                    const entry6 = WaitlistRegisterUserRequest_ProgrammingExperienceEntry.decode(reader, reader.uint32());
                    if (entry6.value !== undefined) {
                        message.programmingExperience[entry6.key] = entry6.value;
                    }
                    continue;
                case 7:
                    if (tag !== 58) {
                        break;
                    }
                    message.appsWanted = reader.string();
                    continue;
                case 8:
                    if (tag !== 64) {
                        break;
                    }
                    message.doesConsentToEmail = reader.bool();
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            userId: isSet(object.userId) ? globalThis.String(object.userId) : "",
            userName: isSet(object.userName) ? globalThis.String(object.userName) : "",
            whatToBuild: isSet(object.whatToBuild) ? globalThis.String(object.whatToBuild) : "",
            botsBuilt: isSet(object.botsBuilt) ? String(object.botsBuilt) : undefined,
            programmingExperience: isObject(object.programmingExperience)
                ? Object.entries(object.programmingExperience).reduce((acc, [key, value]) => {
                    acc[key] = programmingExperienceLevelFromJSON(value);
                    return acc;
                }, {})
                : {},
            appsWanted: isSet(object.appsWanted) ? globalThis.String(object.appsWanted) : "",
            doesConsentToEmail: isSet(object.doesConsentToEmail) ? globalThis.Boolean(object.doesConsentToEmail) : false,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.userId !== "") {
            obj.userId = message.userId;
        }
        if (message.userName !== "") {
            obj.userName = message.userName;
        }
        if (message.whatToBuild !== "") {
            obj.whatToBuild = message.whatToBuild;
        }
        if (message.botsBuilt !== undefined) {
            obj.botsBuilt = message.botsBuilt;
        }
        if (message.programmingExperience) {
            const entries = Object.entries(message.programmingExperience);
            if (entries.length > 0) {
                obj.programmingExperience = {};
                entries.forEach(([k, v]) => {
                    obj.programmingExperience[k] = programmingExperienceLevelToJSON(v);
                });
            }
        }
        if (message.appsWanted !== "") {
            obj.appsWanted = message.appsWanted;
        }
        if (message.doesConsentToEmail !== false) {
            obj.doesConsentToEmail = message.doesConsentToEmail;
        }
        return obj;
    },
    create(base) {
        return WaitlistRegisterUserRequest.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseWaitlistRegisterUserRequest();
        message.userId = object.userId ?? "";
        message.userName = object.userName ?? "";
        message.whatToBuild = object.whatToBuild ?? "";
        message.botsBuilt = object.botsBuilt ?? undefined;
        message.programmingExperience = Object.entries(object.programmingExperience ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = value;
            }
            return acc;
        }, {});
        message.appsWanted = object.appsWanted ?? "";
        message.doesConsentToEmail = object.doesConsentToEmail ?? false;
        return message;
    },
};
messageTypeRegistry.set(WaitlistRegisterUserRequest.$type, WaitlistRegisterUserRequest);
function createBaseWaitlistRegisterUserRequest_ProgrammingExperienceEntry() {
    return { key: "", value: 0 };
}
export const WaitlistRegisterUserRequest_ProgrammingExperienceEntry = {
    $type: "devvit.dev_portal.waitlist.WaitlistRegisterUserRequest.ProgrammingExperienceEntry",
    encode(message, writer = _m0.Writer.create()) {
        if (message.key !== "") {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== 0) {
            writer.uint32(16).int32(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseWaitlistRegisterUserRequest_ProgrammingExperienceEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 10) {
                        break;
                    }
                    message.key = reader.string();
                    continue;
                case 2:
                    if (tag !== 16) {
                        break;
                    }
                    message.value = reader.int32();
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            key: isSet(object.key) ? globalThis.String(object.key) : "",
            value: isSet(object.value) ? programmingExperienceLevelFromJSON(object.value) : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.key !== "") {
            obj.key = message.key;
        }
        if (message.value !== 0) {
            obj.value = programmingExperienceLevelToJSON(message.value);
        }
        return obj;
    },
    create(base) {
        return WaitlistRegisterUserRequest_ProgrammingExperienceEntry.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseWaitlistRegisterUserRequest_ProgrammingExperienceEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? 0;
        return message;
    },
};
messageTypeRegistry.set(WaitlistRegisterUserRequest_ProgrammingExperienceEntry.$type, WaitlistRegisterUserRequest_ProgrammingExperienceEntry);
function createBaseWaitlistRegisterUserResponse() {
    return { success: false, message: undefined };
}
export const WaitlistRegisterUserResponse = {
    $type: "devvit.dev_portal.waitlist.WaitlistRegisterUserResponse",
    encode(message, writer = _m0.Writer.create()) {
        if (message.success !== false) {
            writer.uint32(8).bool(message.success);
        }
        if (message.message !== undefined) {
            StringValue.encode({ value: message.message }, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseWaitlistRegisterUserResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 8) {
                        break;
                    }
                    message.success = reader.bool();
                    continue;
                case 2:
                    if (tag !== 18) {
                        break;
                    }
                    message.message = StringValue.decode(reader, reader.uint32()).value;
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            success: isSet(object.success) ? globalThis.Boolean(object.success) : false,
            message: isSet(object.message) ? String(object.message) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.success !== false) {
            obj.success = message.success;
        }
        if (message.message !== undefined) {
            obj.message = message.message;
        }
        return obj;
    },
    create(base) {
        return WaitlistRegisterUserResponse.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseWaitlistRegisterUserResponse();
        message.success = object.success ?? false;
        message.message = object.message ?? undefined;
        return message;
    },
};
messageTypeRegistry.set(WaitlistRegisterUserResponse.$type, WaitlistRegisterUserResponse);
function createBaseGetCurrentUserStatusResponse() {
    return {
        waitlistStatus: 0,
        acceptedTermsVersion: 0,
        currentTermsVersion: 0,
        hasVerifiedEmail: false,
        doesConsentToEmail: false,
    };
}
export const GetCurrentUserStatusResponse = {
    $type: "devvit.dev_portal.waitlist.GetCurrentUserStatusResponse",
    encode(message, writer = _m0.Writer.create()) {
        if (message.waitlistStatus !== 0) {
            writer.uint32(8).int32(message.waitlistStatus);
        }
        if (message.acceptedTermsVersion !== 0) {
            writer.uint32(16).int32(message.acceptedTermsVersion);
        }
        if (message.currentTermsVersion !== 0) {
            writer.uint32(24).int32(message.currentTermsVersion);
        }
        if (message.hasVerifiedEmail !== false) {
            writer.uint32(32).bool(message.hasVerifiedEmail);
        }
        if (message.doesConsentToEmail !== false) {
            writer.uint32(40).bool(message.doesConsentToEmail);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetCurrentUserStatusResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if (tag !== 8) {
                        break;
                    }
                    message.waitlistStatus = reader.int32();
                    continue;
                case 2:
                    if (tag !== 16) {
                        break;
                    }
                    message.acceptedTermsVersion = reader.int32();
                    continue;
                case 3:
                    if (tag !== 24) {
                        break;
                    }
                    message.currentTermsVersion = reader.int32();
                    continue;
                case 4:
                    if (tag !== 32) {
                        break;
                    }
                    message.hasVerifiedEmail = reader.bool();
                    continue;
                case 5:
                    if (tag !== 40) {
                        break;
                    }
                    message.doesConsentToEmail = reader.bool();
                    continue;
            }
            if ((tag & 7) === 4 || tag === 0) {
                break;
            }
            reader.skipType(tag & 7);
        }
        return message;
    },
    fromJSON(object) {
        return {
            waitlistStatus: isSet(object.waitlistStatus) ? waitlistStatusFromJSON(object.waitlistStatus) : 0,
            acceptedTermsVersion: isSet(object.acceptedTermsVersion) ? globalThis.Number(object.acceptedTermsVersion) : 0,
            currentTermsVersion: isSet(object.currentTermsVersion) ? globalThis.Number(object.currentTermsVersion) : 0,
            hasVerifiedEmail: isSet(object.hasVerifiedEmail) ? globalThis.Boolean(object.hasVerifiedEmail) : false,
            doesConsentToEmail: isSet(object.doesConsentToEmail) ? globalThis.Boolean(object.doesConsentToEmail) : false,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.waitlistStatus !== 0) {
            obj.waitlistStatus = waitlistStatusToJSON(message.waitlistStatus);
        }
        if (message.acceptedTermsVersion !== 0) {
            obj.acceptedTermsVersion = Math.round(message.acceptedTermsVersion);
        }
        if (message.currentTermsVersion !== 0) {
            obj.currentTermsVersion = Math.round(message.currentTermsVersion);
        }
        if (message.hasVerifiedEmail !== false) {
            obj.hasVerifiedEmail = message.hasVerifiedEmail;
        }
        if (message.doesConsentToEmail !== false) {
            obj.doesConsentToEmail = message.doesConsentToEmail;
        }
        return obj;
    },
    create(base) {
        return GetCurrentUserStatusResponse.fromPartial(base ?? {});
    },
    fromPartial(object) {
        const message = createBaseGetCurrentUserStatusResponse();
        message.waitlistStatus = object.waitlistStatus ?? 0;
        message.acceptedTermsVersion = object.acceptedTermsVersion ?? 0;
        message.currentTermsVersion = object.currentTermsVersion ?? 0;
        message.hasVerifiedEmail = object.hasVerifiedEmail ?? false;
        message.doesConsentToEmail = object.doesConsentToEmail ?? false;
        return message;
    },
};
messageTypeRegistry.set(GetCurrentUserStatusResponse.$type, GetCurrentUserStatusResponse);
export const WaitlistServiceName = "devvit.dev_portal.waitlist.Waitlist";
export class WaitlistClientImpl {
    constructor(rpc, opts) {
        this.service = opts?.service || WaitlistServiceName;
        this.rpc = rpc;
        this.IsCurrentUserRegistered = this.IsCurrentUserRegistered.bind(this);
        this.RegisterUser = this.RegisterUser.bind(this);
        this.GetCurrentUserStatus = this.GetCurrentUserStatus.bind(this);
        this.AcceptTermsAndConditions = this.AcceptTermsAndConditions.bind(this);
        this.EnsureDeveloperAccountExists = this.EnsureDeveloperAccountExists.bind(this);
    }
    IsCurrentUserRegistered(request, metadata) {
        const data = Empty.encode(request).finish();
        const promise = this.rpc.request(this.service, "IsCurrentUserRegistered", data, metadata);
        return promise.then((data) => IsCurrentUserRegisteredResponse.decode(_m0.Reader.create(data)));
    }
    RegisterUser(request, metadata) {
        const data = WaitlistRegisterUserRequest.encode(request).finish();
        const promise = this.rpc.request(this.service, "RegisterUser", data, metadata);
        return promise.then((data) => WaitlistRegisterUserResponse.decode(_m0.Reader.create(data)));
    }
    GetCurrentUserStatus(request, metadata) {
        const data = Empty.encode(request).finish();
        const promise = this.rpc.request(this.service, "GetCurrentUserStatus", data, metadata);
        return promise.then((data) => GetCurrentUserStatusResponse.decode(_m0.Reader.create(data)));
    }
    AcceptTermsAndConditions(request, metadata) {
        const data = Empty.encode(request).finish();
        const promise = this.rpc.request(this.service, "AcceptTermsAndConditions", data, metadata);
        return promise.then((data) => Empty.decode(_m0.Reader.create(data)));
    }
    EnsureDeveloperAccountExists(request, metadata) {
        const data = Empty.encode(request).finish();
        const promise = this.rpc.request(this.service, "EnsureDeveloperAccountExists", data, metadata);
        return promise.then((data) => WaitlistRegisterUserResponse.decode(_m0.Reader.create(data)));
    }
}
export const WaitlistDefinition = {
    name: "Waitlist",
    fullName: "devvit.dev_portal.waitlist.Waitlist",
    methods: {
        isCurrentUserRegistered: {
            name: "IsCurrentUserRegistered",
            requestType: Empty,
            requestStream: false,
            responseType: IsCurrentUserRegisteredResponse,
            responseStream: false,
            options: {},
        },
        registerUser: {
            name: "RegisterUser",
            requestType: WaitlistRegisterUserRequest,
            requestStream: false,
            responseType: WaitlistRegisterUserResponse,
            responseStream: false,
            options: {},
        },
        getCurrentUserStatus: {
            name: "GetCurrentUserStatus",
            requestType: Empty,
            requestStream: false,
            responseType: GetCurrentUserStatusResponse,
            responseStream: false,
            options: {},
        },
        acceptTermsAndConditions: {
            name: "AcceptTermsAndConditions",
            requestType: Empty,
            requestStream: false,
            responseType: Empty,
            responseStream: false,
            options: {},
        },
        ensureDeveloperAccountExists: {
            name: "EnsureDeveloperAccountExists",
            requestType: Empty,
            requestStream: false,
            responseType: WaitlistRegisterUserResponse,
            responseStream: false,
            options: {},
        },
    },
};
function isObject(value) {
    return typeof value === "object" && value !== null;
}
function isSet(value) {
    return value !== null && value !== undefined;
}
