import { CustomPostSnapshotRequest } from './custom_post_snapshot.js';
import { CustomPostSnapshot } from '../gql/snapshot.js';
export class CustomPostSnapshotResolverClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.GetCustomPostSnapshot.bind(this);
    }
    GetCustomPostSnapshot(request) {
        const data = CustomPostSnapshotRequest.toJSON(request);
        const promise = this.rpc.request('devvit.gateway.CustomPostSnapshotResolver', 'GetCustomPostSnapshot', 'application/json', data);
        return promise.then((data) => CustomPostSnapshot.fromJSON(data));
    }
}
export class CustomPostSnapshotResolverClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.GetCustomPostSnapshot.bind(this);
    }
    GetCustomPostSnapshot(request) {
        const data = CustomPostSnapshotRequest.encode(request).finish();
        const promise = this.rpc.request('devvit.gateway.CustomPostSnapshotResolver', 'GetCustomPostSnapshot', 'application/protobuf', data);
        return promise.then((data) => CustomPostSnapshot.decode(data));
    }
}
