import { CheckHealthRequest, CheckHealthResponse } from './app_health.js';
export class AppHealthClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.CheckHealth.bind(this);
    }
    CheckHealth(request) {
        const data = CheckHealthRequest.toJSON(request);
        const promise = this.rpc.request('devvit.gateway.utils.v1alpha.AppHealth', 'CheckHealth', 'application/json', data);
        return promise.then((data) => CheckHealthResponse.fromJSON(data));
    }
}
export class AppHealthClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.CheckHealth.bind(this);
    }
    CheckHealth(request) {
        const data = CheckHealthRequest.encode(request).finish();
        const promise = this.rpc.request('devvit.gateway.utils.v1alpha.AppHealth', 'CheckHealth', 'application/protobuf', data);
        return promise.then((data) => CheckHealthResponse.decode(data));
    }
}
