import { Empty } from '../../../google/protobuf/empty.js';
import { Timestamp } from '../../../google/protobuf/timestamp.js';
export class ClockClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.Now.bind(this);
    }
    Now(request) {
        const data = Empty.toJSON(request);
        const promise = this.rpc.request('devvit.plugin.clock.Clock', 'Now', 'application/json', data);
        return promise.then((data) => Timestamp.fromJSON(data));
    }
}
export class ClockClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.Now.bind(this);
    }
    Now(request) {
        const data = Empty.encode(request).finish();
        const promise = this.rpc.request('devvit.plugin.clock.Clock', 'Now', 'application/protobuf', data);
        return promise.then((data) => Timestamp.decode(data));
    }
}
