import { FetchRequest, FetchResponse } from './http.js';
export class HTTPClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.Fetch.bind(this);
    }
    Fetch(request) {
        const data = FetchRequest.toJSON(request);
        const promise = this.rpc.request('devvit.plugin.http.HTTP', 'Fetch', 'application/json', data);
        return promise.then((data) => FetchResponse.fromJSON(data));
    }
}
export class HTTPClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.Fetch.bind(this);
    }
    Fetch(request) {
        const data = FetchRequest.encode(request).finish();
        const promise = this.rpc.request('devvit.plugin.http.HTTP', 'Fetch', 'application/protobuf', data);
        return promise.then((data) => FetchResponse.decode(data));
    }
}
