import { Bundle } from '../buildpack/buildpack_common.js';
import { LinkerResponse } from './linker.js';
export class LinkerClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.Link.bind(this);
    }
    Link(request) {
        const data = Bundle.toJSON(request);
        const promise = this.rpc.request('devvit.plugin.linker.Linker', 'Link', 'application/json', data);
        return promise.then((data) => LinkerResponse.fromJSON(data));
    }
}
export class LinkerClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.Link.bind(this);
    }
    Link(request) {
        const data = Bundle.encode(request).finish();
        const promise = this.rpc.request('devvit.plugin.linker.Linker', 'Link', 'application/protobuf', data);
        return promise.then((data) => LinkerResponse.decode(data));
    }
}
