import { TwirpContext, TwirpServer } from 'twirp-ts';
import { LogErrorMessage, LogErrorResponse, LogEventMessage, LogEventResponse, LogMessage, LogResponse, LogMessages } from './logger.js';
export interface LoggerTwirp<T extends TwirpContext = TwirpContext> {
    Error(ctx: T, request: LogErrorMessage): Promise<LogErrorResponse>;
    Event(ctx: T, request: LogEventMessage): Promise<LogEventResponse>;
    Log(ctx: T, request: LogMessage): Promise<LogResponse>;
    LogBatch(ctx: T, request: LogMessages): Promise<LogResponse>;
    LogStream(ctx: T, request: LogMessage): Promise<LogResponse>;
}
export declare enum LoggerMethod {
    Error = "Error",
    Event = "Event",
    Log = "Log",
    LogBatch = "LogBatch",
    LogStream = "LogStream"
}
export declare const LoggerMethodList: LoggerMethod[];
export declare function createLoggerServer<T extends TwirpContext = TwirpContext>(service: LoggerTwirp<T>): TwirpServer<LoggerTwirp<TwirpContext<import("http").IncomingMessage, import("http").ServerResponse<import("http").IncomingMessage>>>, T>;
//# sourceMappingURL=logger.twirp.d.ts.map