import { MediaUploadRequest, MediaUploadResponse } from './media.js';
export class MediaServiceClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.Upload.bind(this);
    }
    Upload(request) {
        const data = MediaUploadRequest.toJSON(request);
        const promise = this.rpc.request('devvit.plugin.media.MediaService', 'Upload', 'application/json', data);
        return promise.then((data) => MediaUploadResponse.fromJSON(data));
    }
}
export class MediaServiceClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.Upload.bind(this);
    }
    Upload(request) {
        const data = MediaUploadRequest.encode(request).finish();
        const promise = this.rpc.request('devvit.plugin.media.MediaService', 'Upload', 'application/protobuf', data);
        return promise.then((data) => MediaUploadResponse.decode(data));
    }
}
