/**
 * #newmodmail_svc.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { Metadata } from "../../../../../lib/Types.js";
import { Empty } from "../../../../google/protobuf/empty.js";
import { ApproveConversationResponse, ArchiveConversationResponse, BasicConversationRequest, BasicConversationsRequest, BulkReadConversationsRequest, BulkReadConversationsResponse, ConversationUserData, CreateConversationMessageRequest, CreateConversationMessageResponse, CreateConversationRequest, CreateConversationResponse, GetConversationRequest, GetConversationResponse, GetConversationsRequest, GetConversationsResponse, HighlightConversationResponse, MuteConversationRequest, MuteConversationResponse, SubredditsResponse, TempBanRequest, TempBanResponse, UnreadCountResponse } from "./newmodmail_msg.js";
/** NEWMODMAIL - https://www.reddit.com/dev/api#section_modmail */
export interface NewModmail {
    /** https://www.reddit.com/dev/api#POST_api_mod_bulk_read */
    BulkReadConversations(request: BulkReadConversationsRequest, metadata?: Metadata): Promise<BulkReadConversationsResponse>;
    /** https://www.reddit.com/dev/api#GET_api_mod_conversations */
    GetConversations(request: GetConversationsRequest, metadata?: Metadata): Promise<GetConversationsResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations */
    CreateConversation(request: CreateConversationRequest, metadata?: Metadata): Promise<CreateConversationResponse>;
    /** https://www.reddit.com/dev/api#GET_api_mod_conversations_:conversation_id */
    GetConversation(request: GetConversationRequest, metadata?: Metadata): Promise<GetConversationResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id */
    CreateConversationMessage(request: CreateConversationMessageRequest, metadata?: Metadata): Promise<CreateConversationMessageResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_approve */
    ApproveConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<ApproveConversationResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_archive */
    ArchiveConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<ArchiveConversationResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_disapprove */
    DisapproveConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<ApproveConversationResponse>;
    /** https://www.reddit.com/dev/api#DELETE_api_mod_conversations_:conversation_id_highlight */
    UnhighlightConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<HighlightConversationResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_highlight */
    HighlightConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<HighlightConversationResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_mute */
    MuteConversation(request: MuteConversationRequest, metadata?: Metadata): Promise<MuteConversationResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_temp_ban */
    TempBan(request: TempBanRequest, metadata?: Metadata): Promise<TempBanResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_unarchive */
    UnarchiveConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<ArchiveConversationResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_unban */
    Unban(request: BasicConversationRequest, metadata?: Metadata): Promise<TempBanResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_unmute */
    UnmuteConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<MuteConversationResponse>;
    /** https://www.reddit.com/dev/api#GET_api_mod_conversations_:conversation_id_user */
    UserConversations(request: BasicConversationRequest, metadata?: Metadata): Promise<ConversationUserData>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_read */
    Read(request: BasicConversationsRequest, metadata?: Metadata): Promise<Empty>;
    /** https://www.reddit.com/dev/api#GET_api_mod_conversations_subreddits */
    Subreddits(request: Empty, metadata?: Metadata): Promise<SubredditsResponse>;
    /** https://www.reddit.com/dev/api#POST_api_mod_conversations_unread */
    Unread(request: BasicConversationsRequest, metadata?: Metadata): Promise<Empty>;
    /** https://www.reddit.com/dev/api#GET_api_mod_conversations_unread_count */
    UnreadCount(request: Empty, metadata?: Metadata): Promise<UnreadCountResponse>;
}
export declare const NewModmailServiceName = "devvit.plugin.redditapi.newmodmail.NewModmail";
export declare class NewModmailClientImpl implements NewModmail {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    BulkReadConversations(request: BulkReadConversationsRequest, metadata?: Metadata): Promise<BulkReadConversationsResponse>;
    GetConversations(request: GetConversationsRequest, metadata?: Metadata): Promise<GetConversationsResponse>;
    CreateConversation(request: CreateConversationRequest, metadata?: Metadata): Promise<CreateConversationResponse>;
    GetConversation(request: GetConversationRequest, metadata?: Metadata): Promise<GetConversationResponse>;
    CreateConversationMessage(request: CreateConversationMessageRequest, metadata?: Metadata): Promise<CreateConversationMessageResponse>;
    ApproveConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<ApproveConversationResponse>;
    ArchiveConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<ArchiveConversationResponse>;
    DisapproveConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<ApproveConversationResponse>;
    UnhighlightConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<HighlightConversationResponse>;
    HighlightConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<HighlightConversationResponse>;
    MuteConversation(request: MuteConversationRequest, metadata?: Metadata): Promise<MuteConversationResponse>;
    TempBan(request: TempBanRequest, metadata?: Metadata): Promise<TempBanResponse>;
    UnarchiveConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<ArchiveConversationResponse>;
    Unban(request: BasicConversationRequest, metadata?: Metadata): Promise<TempBanResponse>;
    UnmuteConversation(request: BasicConversationRequest, metadata?: Metadata): Promise<MuteConversationResponse>;
    UserConversations(request: BasicConversationRequest, metadata?: Metadata): Promise<ConversationUserData>;
    Read(request: BasicConversationsRequest, metadata?: Metadata): Promise<Empty>;
    Subreddits(request: Empty, metadata?: Metadata): Promise<SubredditsResponse>;
    Unread(request: BasicConversationsRequest, metadata?: Metadata): Promise<Empty>;
    UnreadCount(request: Empty, metadata?: Metadata): Promise<UnreadCountResponse>;
}
/** NEWMODMAIL - https://www.reddit.com/dev/api#section_modmail */
export type NewModmailDefinition = typeof NewModmailDefinition;
export declare const NewModmailDefinition: {
    readonly name: "NewModmail";
    readonly fullName: "devvit.plugin.redditapi.newmodmail.NewModmail";
    readonly methods: {
        /** https://www.reddit.com/dev/api#POST_api_mod_bulk_read */
        readonly bulkReadConversations: {
            readonly name: "BulkReadConversations";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BulkReadConversationsRequest";
                encode(message: BulkReadConversationsRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BulkReadConversationsRequest;
                fromJSON(object: any): BulkReadConversationsRequest;
                toJSON(message: BulkReadConversationsRequest): unknown;
                create(base?: {
                    entity?: string;
                    state?: string;
                }): BulkReadConversationsRequest;
                fromPartial(object: {
                    entity?: string;
                    state?: string;
                }): BulkReadConversationsRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.BulkReadConversationsResponse";
                encode(message: BulkReadConversationsResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BulkReadConversationsResponse;
                fromJSON(object: any): BulkReadConversationsResponse;
                toJSON(message: BulkReadConversationsResponse): unknown;
                create(base?: {
                    conversationIds?: string[];
                }): BulkReadConversationsResponse;
                fromPartial(object: {
                    conversationIds?: string[];
                }): BulkReadConversationsResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#GET_api_mod_conversations */
        readonly getConversations: {
            readonly name: "GetConversations";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.GetConversationsRequest";
                encode(message: GetConversationsRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetConversationsRequest;
                fromJSON(object: any): GetConversationsRequest;
                toJSON(message: GetConversationsRequest): unknown;
                create(base?: {
                    after?: string | undefined | undefined;
                    entity?: string | undefined | undefined;
                    limit?: number | undefined | undefined;
                    sort?: string | undefined | undefined;
                    state?: string | undefined | undefined;
                }): GetConversationsRequest;
                fromPartial(object: {
                    after?: string | undefined | undefined;
                    entity?: string | undefined | undefined;
                    limit?: number | undefined | undefined;
                    sort?: string | undefined | undefined;
                    state?: string | undefined | undefined;
                }): GetConversationsRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.GetConversationsResponse";
                encode(message: GetConversationsResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetConversationsResponse;
                fromJSON(object: any): GetConversationsResponse;
                toJSON(message: GetConversationsResponse): unknown;
                create(base?: {
                    conversations?: {
                        [x: string]: {
                            isAuto?: boolean | undefined | undefined;
                            participant?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            objIds?: {
                                id?: string | undefined | undefined;
                                key?: string | undefined | undefined;
                            }[];
                            isRepliable?: boolean | undefined | undefined;
                            lastUserUpdate?: string | undefined | undefined;
                            isInternal?: boolean | undefined | undefined;
                            lastModUpdate?: string | undefined | undefined;
                            authors?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            }[];
                            lastUpdated?: string | undefined | undefined;
                            legacyFirstMessageId?: string | undefined | undefined;
                            state?: number | undefined | undefined;
                            conversationType?: string | undefined | undefined;
                            lastUnread?: string | undefined | undefined;
                            owner?: {
                                displayName?: string | undefined | undefined;
                                type?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                            } | undefined;
                            subject?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            isHighlighted?: boolean | undefined | undefined;
                            numMessages?: number | undefined | undefined;
                            modActions?: {
                                [x: string]: {
                                    date?: string | undefined | undefined;
                                    actionTypeId?: number | undefined | undefined;
                                    id?: string | undefined | undefined;
                                    author?: {
                                        isMod?: boolean | undefined | undefined;
                                        isAdmin?: boolean | undefined | undefined;
                                        name?: string | undefined | undefined;
                                        isHidden?: boolean | undefined | undefined;
                                        id?: number | undefined | undefined;
                                        isDeleted?: boolean | undefined | undefined;
                                    } | undefined;
                                } | undefined;
                            };
                        } | undefined;
                    };
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    viewerId?: string | undefined | undefined;
                    conversationIds?: string[];
                }): GetConversationsResponse;
                fromPartial(object: {
                    conversations?: {
                        [x: string]: {
                            isAuto?: boolean | undefined | undefined;
                            participant?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            objIds?: {
                                id?: string | undefined | undefined;
                                key?: string | undefined | undefined;
                            }[];
                            isRepliable?: boolean | undefined | undefined;
                            lastUserUpdate?: string | undefined | undefined;
                            isInternal?: boolean | undefined | undefined;
                            lastModUpdate?: string | undefined | undefined;
                            authors?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            }[];
                            lastUpdated?: string | undefined | undefined;
                            legacyFirstMessageId?: string | undefined | undefined;
                            state?: number | undefined | undefined;
                            conversationType?: string | undefined | undefined;
                            lastUnread?: string | undefined | undefined;
                            owner?: {
                                displayName?: string | undefined | undefined;
                                type?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                            } | undefined;
                            subject?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            isHighlighted?: boolean | undefined | undefined;
                            numMessages?: number | undefined | undefined;
                            modActions?: {
                                [x: string]: {
                                    date?: string | undefined | undefined;
                                    actionTypeId?: number | undefined | undefined;
                                    id?: string | undefined | undefined;
                                    author?: {
                                        isMod?: boolean | undefined | undefined;
                                        isAdmin?: boolean | undefined | undefined;
                                        name?: string | undefined | undefined;
                                        isHidden?: boolean | undefined | undefined;
                                        id?: number | undefined | undefined;
                                        isDeleted?: boolean | undefined | undefined;
                                    } | undefined;
                                } | undefined;
                            };
                        } | undefined;
                    };
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    viewerId?: string | undefined | undefined;
                    conversationIds?: string[];
                }): GetConversationsResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations */
        readonly createConversation: {
            readonly name: "CreateConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.CreateConversationRequest";
                encode(message: CreateConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): CreateConversationRequest;
                fromJSON(object: any): CreateConversationRequest;
                toJSON(message: CreateConversationRequest): unknown;
                create(base?: {
                    body?: string;
                    isAuthorHidden?: boolean;
                    srName?: string;
                    subject?: string;
                    to?: string | undefined | undefined;
                }): CreateConversationRequest;
                fromPartial(object: {
                    body?: string;
                    isAuthorHidden?: boolean;
                    srName?: string;
                    subject?: string;
                    to?: string | undefined | undefined;
                }): CreateConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.CreateConversationResponse";
                encode(message: CreateConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): CreateConversationResponse;
                fromJSON(object: any): CreateConversationResponse;
                toJSON(message: CreateConversationResponse): unknown;
                create(base?: {
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                    explanation?: string | undefined | undefined;
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                }): CreateConversationResponse;
                fromPartial(object: {
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                    explanation?: string | undefined | undefined;
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                }): CreateConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#GET_api_mod_conversations_:conversation_id */
        readonly getConversation: {
            readonly name: "GetConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.GetConversationRequest";
                encode(message: GetConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetConversationRequest;
                fromJSON(object: any): GetConversationRequest;
                toJSON(message: GetConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                    markRead?: boolean;
                }): GetConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                    markRead?: boolean;
                }): GetConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.GetConversationResponse";
                encode(message: GetConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): GetConversationResponse;
                fromJSON(object: any): GetConversationResponse;
                toJSON(message: GetConversationResponse): unknown;
                create(base?: {
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    participantSubreddit?: {
                        typeUrl?: string;
                        value?: Uint8Array;
                    } | undefined;
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                }): GetConversationResponse;
                fromPartial(object: {
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    participantSubreddit?: {
                        typeUrl?: string;
                        value?: Uint8Array;
                    } | undefined;
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                }): GetConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id */
        readonly createConversationMessage: {
            readonly name: "CreateConversationMessage";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.CreateConversationMessageRequest";
                encode(message: CreateConversationMessageRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): CreateConversationMessageRequest;
                fromJSON(object: any): CreateConversationMessageRequest;
                toJSON(message: CreateConversationMessageRequest): unknown;
                create(base?: {
                    body?: string;
                    isAuthorHidden?: boolean;
                    isInternal?: boolean;
                    conversationId?: string;
                }): CreateConversationMessageRequest;
                fromPartial(object: {
                    body?: string;
                    isAuthorHidden?: boolean;
                    isInternal?: boolean;
                    conversationId?: string;
                }): CreateConversationMessageRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.CreateConversationMessageResponse";
                encode(message: CreateConversationMessageResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): CreateConversationMessageResponse;
                fromJSON(object: any): CreateConversationMessageResponse;
                toJSON(message: CreateConversationMessageResponse): unknown;
                create(base?: {
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                }): CreateConversationMessageResponse;
                fromPartial(object: {
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                }): CreateConversationMessageResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_approve */
        readonly approveConversation: {
            readonly name: "ApproveConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationRequest";
                encode(message: BasicConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationRequest;
                fromJSON(object: any): BasicConversationRequest;
                toJSON(message: BasicConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                }): BasicConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                }): BasicConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.ApproveConversationResponse";
                encode(message: ApproveConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): ApproveConversationResponse;
                fromJSON(object: any): ApproveConversationResponse;
                toJSON(message: ApproveConversationResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                    explanation?: string | undefined | undefined;
                }): ApproveConversationResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                    explanation?: string | undefined | undefined;
                }): ApproveConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_archive */
        readonly archiveConversation: {
            readonly name: "ArchiveConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationRequest";
                encode(message: BasicConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationRequest;
                fromJSON(object: any): BasicConversationRequest;
                toJSON(message: BasicConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                }): BasicConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                }): BasicConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.ArchiveConversationResponse";
                encode(message: ArchiveConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): ArchiveConversationResponse;
                fromJSON(object: any): ArchiveConversationResponse;
                toJSON(message: ArchiveConversationResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                }): ArchiveConversationResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                }): ArchiveConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_disapprove */
        readonly disapproveConversation: {
            readonly name: "DisapproveConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationRequest";
                encode(message: BasicConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationRequest;
                fromJSON(object: any): BasicConversationRequest;
                toJSON(message: BasicConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                }): BasicConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                }): BasicConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.ApproveConversationResponse";
                encode(message: ApproveConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): ApproveConversationResponse;
                fromJSON(object: any): ApproveConversationResponse;
                toJSON(message: ApproveConversationResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                    explanation?: string | undefined | undefined;
                }): ApproveConversationResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                    explanation?: string | undefined | undefined;
                }): ApproveConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#DELETE_api_mod_conversations_:conversation_id_highlight */
        readonly unhighlightConversation: {
            readonly name: "UnhighlightConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationRequest";
                encode(message: BasicConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationRequest;
                fromJSON(object: any): BasicConversationRequest;
                toJSON(message: BasicConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                }): BasicConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                }): BasicConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.HighlightConversationResponse";
                encode(message: HighlightConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): HighlightConversationResponse;
                fromJSON(object: any): HighlightConversationResponse;
                toJSON(message: HighlightConversationResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                }): HighlightConversationResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                }): HighlightConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_highlight */
        readonly highlightConversation: {
            readonly name: "HighlightConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationRequest";
                encode(message: BasicConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationRequest;
                fromJSON(object: any): BasicConversationRequest;
                toJSON(message: BasicConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                }): BasicConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                }): BasicConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.HighlightConversationResponse";
                encode(message: HighlightConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): HighlightConversationResponse;
                fromJSON(object: any): HighlightConversationResponse;
                toJSON(message: HighlightConversationResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                }): HighlightConversationResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                }): HighlightConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_mute */
        readonly muteConversation: {
            readonly name: "MuteConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.MuteConversationRequest";
                encode(message: MuteConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): MuteConversationRequest;
                fromJSON(object: any): MuteConversationRequest;
                toJSON(message: MuteConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                    numHours?: number;
                }): MuteConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                    numHours?: number;
                }): MuteConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.MuteConversationResponse";
                encode(message: MuteConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): MuteConversationResponse;
                fromJSON(object: any): MuteConversationResponse;
                toJSON(message: MuteConversationResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                }): MuteConversationResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                }): MuteConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_temp_ban */
        readonly tempBan: {
            readonly name: "TempBan";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.TempBanRequest";
                encode(message: TempBanRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): TempBanRequest;
                fromJSON(object: any): TempBanRequest;
                toJSON(message: TempBanRequest): unknown;
                create(base?: {
                    conversationId?: string;
                    duration?: number;
                }): TempBanRequest;
                fromPartial(object: {
                    conversationId?: string;
                    duration?: number;
                }): TempBanRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.TempBanResponse";
                encode(message: TempBanResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): TempBanResponse;
                fromJSON(object: any): TempBanResponse;
                toJSON(message: TempBanResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                }): TempBanResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                }): TempBanResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_unarchive */
        readonly unarchiveConversation: {
            readonly name: "UnarchiveConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationRequest";
                encode(message: BasicConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationRequest;
                fromJSON(object: any): BasicConversationRequest;
                toJSON(message: BasicConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                }): BasicConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                }): BasicConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.ArchiveConversationResponse";
                encode(message: ArchiveConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): ArchiveConversationResponse;
                fromJSON(object: any): ArchiveConversationResponse;
                toJSON(message: ArchiveConversationResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                }): ArchiveConversationResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    conversation?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                }): ArchiveConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_unban */
        readonly unban: {
            readonly name: "Unban";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationRequest";
                encode(message: BasicConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationRequest;
                fromJSON(object: any): BasicConversationRequest;
                toJSON(message: BasicConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                }): BasicConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                }): BasicConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.TempBanResponse";
                encode(message: TempBanResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): TempBanResponse;
                fromJSON(object: any): TempBanResponse;
                toJSON(message: TempBanResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                }): TempBanResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                    fields?: string[];
                    reason?: string | undefined | undefined;
                    message?: string | undefined | undefined;
                }): TempBanResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_:conversation_id_unmute */
        readonly unmuteConversation: {
            readonly name: "UnmuteConversation";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationRequest";
                encode(message: BasicConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationRequest;
                fromJSON(object: any): BasicConversationRequest;
                toJSON(message: BasicConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                }): BasicConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                }): BasicConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.MuteConversationResponse";
                encode(message: MuteConversationResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): MuteConversationResponse;
                fromJSON(object: any): MuteConversationResponse;
                toJSON(message: MuteConversationResponse): unknown;
                create(base?: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                }): MuteConversationResponse;
                fromPartial(object: {
                    conversations?: {
                        isAuto?: boolean | undefined | undefined;
                        participant?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        } | undefined;
                        objIds?: {
                            id?: string | undefined | undefined;
                            key?: string | undefined | undefined;
                        }[];
                        isRepliable?: boolean | undefined | undefined;
                        lastUserUpdate?: string | undefined | undefined;
                        isInternal?: boolean | undefined | undefined;
                        lastModUpdate?: string | undefined | undefined;
                        authors?: {
                            isMod?: boolean | undefined | undefined;
                            isAdmin?: boolean | undefined | undefined;
                            name?: string | undefined | undefined;
                            isOp?: boolean | undefined | undefined;
                            isParticipant?: boolean | undefined | undefined;
                            isApproved?: boolean | undefined | undefined;
                            isHidden?: boolean | undefined | undefined;
                            id?: number | undefined | undefined;
                            isDeleted?: boolean | undefined | undefined;
                        }[];
                        lastUpdated?: string | undefined | undefined;
                        legacyFirstMessageId?: string | undefined | undefined;
                        state?: number | undefined | undefined;
                        conversationType?: string | undefined | undefined;
                        lastUnread?: string | undefined | undefined;
                        owner?: {
                            displayName?: string | undefined | undefined;
                            type?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                        } | undefined;
                        subject?: string | undefined | undefined;
                        id?: string | undefined | undefined;
                        isHighlighted?: boolean | undefined | undefined;
                        numMessages?: number | undefined | undefined;
                        modActions?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                actionTypeId?: number | undefined | undefined;
                                id?: string | undefined | undefined;
                                author?: {
                                    isMod?: boolean | undefined | undefined;
                                    isAdmin?: boolean | undefined | undefined;
                                    name?: string | undefined | undefined;
                                    isHidden?: boolean | undefined | undefined;
                                    id?: number | undefined | undefined;
                                    isDeleted?: boolean | undefined | undefined;
                                } | undefined;
                            } | undefined;
                        };
                    } | undefined;
                    messages?: {
                        [x: string]: {
                            body?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isOp?: boolean | undefined | undefined;
                                isParticipant?: boolean | undefined | undefined;
                                isApproved?: boolean | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                            isInternal?: boolean | undefined | undefined;
                            date?: string | undefined | undefined;
                            bodyMarkdown?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            participatingAs?: string | undefined | undefined;
                        } | undefined;
                    };
                    user?: {
                        recentComments?: {
                            [x: string]: {
                                comment?: string | undefined | undefined;
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        muteStatus?: {
                            muteCount?: number | undefined | undefined;
                            isMuted?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        name?: string | undefined | undefined;
                        created?: string | undefined | undefined;
                        banStatus?: {
                            isBanned?: boolean | undefined | undefined;
                            isPermanent?: boolean | undefined | undefined;
                            endDate?: string | undefined | undefined;
                            reason?: string | undefined | undefined;
                        } | undefined;
                        isSuspended?: boolean | undefined | undefined;
                        approveStatus?: {
                            isApproved?: boolean | undefined | undefined;
                        } | undefined;
                        isShadowBanned?: boolean | undefined | undefined;
                        recentPosts?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                title?: string | undefined | undefined;
                            } | undefined;
                        };
                        recentConvos?: {
                            [x: string]: {
                                date?: string | undefined | undefined;
                                permalink?: string | undefined | undefined;
                                id?: string | undefined | undefined;
                                subject?: string | undefined | undefined;
                            } | undefined;
                        };
                        id?: string | undefined | undefined;
                    } | undefined;
                    modActions?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            actionTypeId?: number | undefined | undefined;
                            id?: string | undefined | undefined;
                            author?: {
                                isMod?: boolean | undefined | undefined;
                                isAdmin?: boolean | undefined | undefined;
                                name?: string | undefined | undefined;
                                isHidden?: boolean | undefined | undefined;
                                id?: number | undefined | undefined;
                                isDeleted?: boolean | undefined | undefined;
                            } | undefined;
                        } | undefined;
                    };
                }): MuteConversationResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#GET_api_mod_conversations_:conversation_id_user */
        readonly userConversations: {
            readonly name: "UserConversations";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationRequest";
                encode(message: BasicConversationRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationRequest;
                fromJSON(object: any): BasicConversationRequest;
                toJSON(message: BasicConversationRequest): unknown;
                create(base?: {
                    conversationId?: string;
                }): BasicConversationRequest;
                fromPartial(object: {
                    conversationId?: string;
                }): BasicConversationRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.ConversationUserData";
                encode(message: ConversationUserData, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): ConversationUserData;
                fromJSON(object: any): ConversationUserData;
                toJSON(message: ConversationUserData): unknown;
                create(base?: {
                    recentComments?: {
                        [x: string]: {
                            comment?: string | undefined | undefined;
                            date?: string | undefined | undefined;
                            permalink?: string | undefined | undefined;
                            title?: string | undefined | undefined;
                        } | undefined;
                    };
                    muteStatus?: {
                        muteCount?: number | undefined | undefined;
                        isMuted?: boolean | undefined | undefined;
                        endDate?: string | undefined | undefined;
                        reason?: string | undefined | undefined;
                    } | undefined;
                    name?: string | undefined | undefined;
                    created?: string | undefined | undefined;
                    banStatus?: {
                        isBanned?: boolean | undefined | undefined;
                        isPermanent?: boolean | undefined | undefined;
                        endDate?: string | undefined | undefined;
                        reason?: string | undefined | undefined;
                    } | undefined;
                    isSuspended?: boolean | undefined | undefined;
                    approveStatus?: {
                        isApproved?: boolean | undefined | undefined;
                    } | undefined;
                    isShadowBanned?: boolean | undefined | undefined;
                    recentPosts?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            permalink?: string | undefined | undefined;
                            title?: string | undefined | undefined;
                        } | undefined;
                    };
                    recentConvos?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            permalink?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            subject?: string | undefined | undefined;
                        } | undefined;
                    };
                    id?: string | undefined | undefined;
                }): ConversationUserData;
                fromPartial(object: {
                    recentComments?: {
                        [x: string]: {
                            comment?: string | undefined | undefined;
                            date?: string | undefined | undefined;
                            permalink?: string | undefined | undefined;
                            title?: string | undefined | undefined;
                        } | undefined;
                    };
                    muteStatus?: {
                        muteCount?: number | undefined | undefined;
                        isMuted?: boolean | undefined | undefined;
                        endDate?: string | undefined | undefined;
                        reason?: string | undefined | undefined;
                    } | undefined;
                    name?: string | undefined | undefined;
                    created?: string | undefined | undefined;
                    banStatus?: {
                        isBanned?: boolean | undefined | undefined;
                        isPermanent?: boolean | undefined | undefined;
                        endDate?: string | undefined | undefined;
                        reason?: string | undefined | undefined;
                    } | undefined;
                    isSuspended?: boolean | undefined | undefined;
                    approveStatus?: {
                        isApproved?: boolean | undefined | undefined;
                    } | undefined;
                    isShadowBanned?: boolean | undefined | undefined;
                    recentPosts?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            permalink?: string | undefined | undefined;
                            title?: string | undefined | undefined;
                        } | undefined;
                    };
                    recentConvos?: {
                        [x: string]: {
                            date?: string | undefined | undefined;
                            permalink?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            subject?: string | undefined | undefined;
                        } | undefined;
                    };
                    id?: string | undefined | undefined;
                }): ConversationUserData;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_read */
        readonly read: {
            readonly name: "Read";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationsRequest";
                encode(message: BasicConversationsRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationsRequest;
                fromJSON(object: any): BasicConversationsRequest;
                toJSON(message: BasicConversationsRequest): unknown;
                create(base?: {
                    conversationIds?: string;
                }): BasicConversationsRequest;
                fromPartial(object: {
                    conversationIds?: string;
                }): BasicConversationsRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "google.protobuf.Empty";
                encode(_: Empty, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Empty;
                fromJSON(_: any): Empty;
                toJSON(_: Empty): unknown;
                create(base?: {}): Empty;
                fromPartial(_: {}): Empty;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#GET_api_mod_conversations_subreddits */
        readonly subreddits: {
            readonly name: "Subreddits";
            readonly requestType: {
                $type: "google.protobuf.Empty";
                encode(_: Empty, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Empty;
                fromJSON(_: any): Empty;
                toJSON(_: Empty): unknown;
                create(base?: {}): Empty;
                fromPartial(_: {}): Empty;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.SubredditsResponse";
                encode(message: SubredditsResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): SubredditsResponse;
                fromJSON(object: any): SubredditsResponse;
                toJSON(message: SubredditsResponse): unknown;
                create(base?: {
                    subreddits?: {
                        [x: string]: {
                            communityIcon?: string | undefined | undefined;
                            keyColor?: string | undefined | undefined;
                            displayName?: string | undefined | undefined;
                            name?: string | undefined | undefined;
                            subscribers?: number | undefined | undefined;
                            primaryColor?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            lastUpdated?: string | undefined | undefined;
                            icon?: string | undefined | undefined;
                        } | undefined;
                    };
                }): SubredditsResponse;
                fromPartial(object: {
                    subreddits?: {
                        [x: string]: {
                            communityIcon?: string | undefined | undefined;
                            keyColor?: string | undefined | undefined;
                            displayName?: string | undefined | undefined;
                            name?: string | undefined | undefined;
                            subscribers?: number | undefined | undefined;
                            primaryColor?: string | undefined | undefined;
                            id?: string | undefined | undefined;
                            lastUpdated?: string | undefined | undefined;
                            icon?: string | undefined | undefined;
                        } | undefined;
                    };
                }): SubredditsResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#POST_api_mod_conversations_unread */
        readonly unread: {
            readonly name: "Unread";
            readonly requestType: {
                $type: "devvit.plugin.redditapi.newmodmail.BasicConversationsRequest";
                encode(message: BasicConversationsRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): BasicConversationsRequest;
                fromJSON(object: any): BasicConversationsRequest;
                toJSON(message: BasicConversationsRequest): unknown;
                create(base?: {
                    conversationIds?: string;
                }): BasicConversationsRequest;
                fromPartial(object: {
                    conversationIds?: string;
                }): BasicConversationsRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "google.protobuf.Empty";
                encode(_: Empty, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Empty;
                fromJSON(_: any): Empty;
                toJSON(_: Empty): unknown;
                create(base?: {}): Empty;
                fromPartial(_: {}): Empty;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
        /** https://www.reddit.com/dev/api#GET_api_mod_conversations_unread_count */
        readonly unreadCount: {
            readonly name: "UnreadCount";
            readonly requestType: {
                $type: "google.protobuf.Empty";
                encode(_: Empty, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Empty;
                fromJSON(_: any): Empty;
                toJSON(_: Empty): unknown;
                create(base?: {}): Empty;
                fromPartial(_: {}): Empty;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.redditapi.newmodmail.UnreadCountResponse";
                encode(message: UnreadCountResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): UnreadCountResponse;
                fromJSON(object: any): UnreadCountResponse;
                toJSON(message: UnreadCountResponse): unknown;
                create(base?: {
                    archived?: number | undefined | undefined;
                    appeals?: number | undefined | undefined;
                    highlighted?: number | undefined | undefined;
                    notifications?: number | undefined | undefined;
                    joinRequests?: number | undefined | undefined;
                    filtered?: number | undefined | undefined;
                    new?: number | undefined | undefined;
                    inprogress?: number | undefined | undefined;
                    mod?: number | undefined | undefined;
                }): UnreadCountResponse;
                fromPartial(object: {
                    archived?: number | undefined | undefined;
                    appeals?: number | undefined | undefined;
                    highlighted?: number | undefined | undefined;
                    notifications?: number | undefined | undefined;
                    joinRequests?: number | undefined | undefined;
                    filtered?: number | undefined | undefined;
                    new?: number | undefined | undefined;
                    inprogress?: number | undefined | undefined;
                    mod?: number | undefined | undefined;
                }): UnreadCountResponse;
            };
            readonly responseStream: false;
            readonly options: {
                readonly _unknownFields: {
                    readonly 480010: readonly [Uint8Array<ArrayBuffer>, Uint8Array<ArrayBuffer>];
                };
            };
        };
    };
};
interface Rpc {
    request(service: string, method: string, data: Uint8Array, metadata?: Metadata): Promise<Uint8Array>;
}
export {};
//# sourceMappingURL=newmodmail_svc.d.ts.map