import { AboutWhereRequest, BasicSubredditRequest, DeleteSrImgRequest, BasicSearchRequest, SearchRedditNamesResponse, SearchSubredditsResponse, SiteAdminRequest, SubmitTextResponse, SubredditAutocompleteRequest, SubredditAutocompleteResponse, SubredditStylesheetRequest, SubscribeRequest, UploadSrImgRequest, UploadSrImgResponse, SubredditPostRequirementsResponse, SubredditAboutResponse, SubredditAboutEditRequest, SubredditAboutEditResponse, SubredditAboutRulesResponse, SubredditAboutTrafficResponse, StickyRequest, StickyResponse, BasicWhereRequest, SubredditsSearchRequest, SubredditsSearchResponse, UsersSearchRequest, UserSearchResponse, SubredditAddRemovalReasonRequest, SubredditAddRemovalReasonResponse, SubredditGetRemovalReasonsRequest, SubredditGetRemovalReasonsResponse } from './subreddits_msg.js';
import { Listing, JsonStatus } from '../common/common_msg.js';
import { Empty } from '../../../../google/protobuf/empty.js';
import { StringValue } from '../../../../google/protobuf/wrappers.js';
interface Rpc {
    request(service: string, method: string, contentType: 'application/json' | 'application/protobuf', data: object | Uint8Array): Promise<object | Uint8Array>;
}
export interface SubredditsClient {
    AboutWhere(request: AboutWhereRequest): Promise<Listing>;
    DeleteSrBanner(request: BasicSubredditRequest): Promise<JsonStatus>;
    DeleteSrHeader(request: BasicSubredditRequest): Promise<JsonStatus>;
    DeleteSrIcon(request: BasicSubredditRequest): Promise<JsonStatus>;
    DeleteSrImg(request: DeleteSrImgRequest): Promise<JsonStatus>;
    SearchRedditNames(request: BasicSearchRequest): Promise<SearchRedditNamesResponse>;
    SearchSubreddits(request: BasicSearchRequest): Promise<SearchSubredditsResponse>;
    SiteAdmin(request: SiteAdminRequest): Promise<JsonStatus>;
    SubmitText(request: BasicSubredditRequest): Promise<SubmitTextResponse>;
    SubredditAutocomplete(request: SubredditAutocompleteRequest): Promise<SubredditAutocompleteResponse>;
    SubredditStylesheet(request: SubredditStylesheetRequest): Promise<JsonStatus>;
    Subscribe(request: SubscribeRequest): Promise<Empty>;
    UploadSrImg(request: UploadSrImgRequest): Promise<UploadSrImgResponse>;
    SubredditPostRequirements(request: BasicSubredditRequest): Promise<SubredditPostRequirementsResponse>;
    SubredditAbout(request: BasicSubredditRequest): Promise<SubredditAboutResponse>;
    SubredditAboutEdit(request: SubredditAboutEditRequest): Promise<SubredditAboutEditResponse>;
    SubredditAboutRules(request: BasicSubredditRequest): Promise<SubredditAboutRulesResponse>;
    SubredditAboutTraffic(request: BasicSubredditRequest): Promise<SubredditAboutTrafficResponse>;
    Sidebar(request: BasicSubredditRequest): Promise<StringValue>;
    Sticky(request: StickyRequest): Promise<StickyResponse>;
    SubredditsMineWhere(request: BasicWhereRequest): Promise<Listing>;
    SubredditsSearch(request: SubredditsSearchRequest): Promise<SubredditsSearchResponse>;
    SubredditsWhere(request: BasicWhereRequest): Promise<SubredditsSearchResponse>;
    UsersSearch(request: UsersSearchRequest): Promise<UserSearchResponse>;
    UsersWhere(request: BasicWhereRequest): Promise<SubredditsSearchResponse>;
    SubredditAddRemovalReason(request: SubredditAddRemovalReasonRequest): Promise<SubredditAddRemovalReasonResponse>;
    SubredditGetRemovalReasons(request: SubredditGetRemovalReasonsRequest): Promise<SubredditGetRemovalReasonsResponse>;
}
export declare class SubredditsClientJSON implements SubredditsClient {
    private readonly rpc;
    constructor(rpc: Rpc);
    AboutWhere(request: AboutWhereRequest): Promise<Listing>;
    DeleteSrBanner(request: BasicSubredditRequest): Promise<JsonStatus>;
    DeleteSrHeader(request: BasicSubredditRequest): Promise<JsonStatus>;
    DeleteSrIcon(request: BasicSubredditRequest): Promise<JsonStatus>;
    DeleteSrImg(request: DeleteSrImgRequest): Promise<JsonStatus>;
    SearchRedditNames(request: BasicSearchRequest): Promise<SearchRedditNamesResponse>;
    SearchSubreddits(request: BasicSearchRequest): Promise<SearchSubredditsResponse>;
    SiteAdmin(request: SiteAdminRequest): Promise<JsonStatus>;
    SubmitText(request: BasicSubredditRequest): Promise<SubmitTextResponse>;
    SubredditAutocomplete(request: SubredditAutocompleteRequest): Promise<SubredditAutocompleteResponse>;
    SubredditStylesheet(request: SubredditStylesheetRequest): Promise<JsonStatus>;
    Subscribe(request: SubscribeRequest): Promise<Empty>;
    UploadSrImg(request: UploadSrImgRequest): Promise<UploadSrImgResponse>;
    SubredditPostRequirements(request: BasicSubredditRequest): Promise<SubredditPostRequirementsResponse>;
    SubredditAbout(request: BasicSubredditRequest): Promise<SubredditAboutResponse>;
    SubredditAboutEdit(request: SubredditAboutEditRequest): Promise<SubredditAboutEditResponse>;
    SubredditAboutRules(request: BasicSubredditRequest): Promise<SubredditAboutRulesResponse>;
    SubredditAboutTraffic(request: BasicSubredditRequest): Promise<SubredditAboutTrafficResponse>;
    Sidebar(request: BasicSubredditRequest): Promise<StringValue>;
    Sticky(request: StickyRequest): Promise<StickyResponse>;
    SubredditsMineWhere(request: BasicWhereRequest): Promise<Listing>;
    SubredditsSearch(request: SubredditsSearchRequest): Promise<SubredditsSearchResponse>;
    SubredditsWhere(request: BasicWhereRequest): Promise<SubredditsSearchResponse>;
    UsersSearch(request: UsersSearchRequest): Promise<UserSearchResponse>;
    UsersWhere(request: BasicWhereRequest): Promise<SubredditsSearchResponse>;
    SubredditAddRemovalReason(request: SubredditAddRemovalReasonRequest): Promise<SubredditAddRemovalReasonResponse>;
    SubredditGetRemovalReasons(request: SubredditGetRemovalReasonsRequest): Promise<SubredditGetRemovalReasonsResponse>;
}
export declare class SubredditsClientProtobuf implements SubredditsClient {
    private readonly rpc;
    constructor(rpc: Rpc);
    AboutWhere(request: AboutWhereRequest): Promise<Listing>;
    DeleteSrBanner(request: BasicSubredditRequest): Promise<JsonStatus>;
    DeleteSrHeader(request: BasicSubredditRequest): Promise<JsonStatus>;
    DeleteSrIcon(request: BasicSubredditRequest): Promise<JsonStatus>;
    DeleteSrImg(request: DeleteSrImgRequest): Promise<JsonStatus>;
    SearchRedditNames(request: BasicSearchRequest): Promise<SearchRedditNamesResponse>;
    SearchSubreddits(request: BasicSearchRequest): Promise<SearchSubredditsResponse>;
    SiteAdmin(request: SiteAdminRequest): Promise<JsonStatus>;
    SubmitText(request: BasicSubredditRequest): Promise<SubmitTextResponse>;
    SubredditAutocomplete(request: SubredditAutocompleteRequest): Promise<SubredditAutocompleteResponse>;
    SubredditStylesheet(request: SubredditStylesheetRequest): Promise<JsonStatus>;
    Subscribe(request: SubscribeRequest): Promise<Empty>;
    UploadSrImg(request: UploadSrImgRequest): Promise<UploadSrImgResponse>;
    SubredditPostRequirements(request: BasicSubredditRequest): Promise<SubredditPostRequirementsResponse>;
    SubredditAbout(request: BasicSubredditRequest): Promise<SubredditAboutResponse>;
    SubredditAboutEdit(request: SubredditAboutEditRequest): Promise<SubredditAboutEditResponse>;
    SubredditAboutRules(request: BasicSubredditRequest): Promise<SubredditAboutRulesResponse>;
    SubredditAboutTraffic(request: BasicSubredditRequest): Promise<SubredditAboutTrafficResponse>;
    Sidebar(request: BasicSubredditRequest): Promise<StringValue>;
    Sticky(request: StickyRequest): Promise<StickyResponse>;
    SubredditsMineWhere(request: BasicWhereRequest): Promise<Listing>;
    SubredditsSearch(request: SubredditsSearchRequest): Promise<SubredditsSearchResponse>;
    SubredditsWhere(request: BasicWhereRequest): Promise<SubredditsSearchResponse>;
    UsersSearch(request: UsersSearchRequest): Promise<UserSearchResponse>;
    UsersWhere(request: BasicWhereRequest): Promise<SubredditsSearchResponse>;
    SubredditAddRemovalReason(request: SubredditAddRemovalReasonRequest): Promise<SubredditAddRemovalReasonResponse>;
    SubredditGetRemovalReasons(request: SubredditGetRemovalReasonsRequest): Promise<SubredditGetRemovalReasonsResponse>;
}
export {};
//# sourceMappingURL=subreddits_svc.twirp-client.d.ts.map