import { TwirpContext, TwirpServer } from 'twirp-ts';
import { GetWikiPagesRequest, GetWikiPagesResponse, GetWikiPageRequest, GetWikiPageResponse, EditWikiPageRequest, HideWikiPageRevisionRequest, HideWikiPageRevisionResponse, GetWikiPageRevisionsRequest, WikiPageRevisionListing, GetWikiRevisionsRequest, RevertWikiPageRequest, GetWikiPageSettingsRequest, WikiPageSettings, UpdateWikiPageSettingsRequest, AllowEditorRequest } from './wiki_msg.js';
import { Empty } from '../../../../google/protobuf/empty.js';
export interface WikiTwirp<T extends TwirpContext = TwirpContext> {
    GetWikiPages(ctx: T, request: GetWikiPagesRequest): Promise<GetWikiPagesResponse>;
    GetWikiPage(ctx: T, request: GetWikiPageRequest): Promise<GetWikiPageResponse>;
    EditWikiPage(ctx: T, request: EditWikiPageRequest): Promise<Empty>;
    HideWikiPageRevision(ctx: T, request: HideWikiPageRevisionRequest): Promise<HideWikiPageRevisionResponse>;
    GetWikiPageRevisions(ctx: T, request: GetWikiPageRevisionsRequest): Promise<WikiPageRevisionListing>;
    GetWikiRevisions(ctx: T, request: GetWikiRevisionsRequest): Promise<WikiPageRevisionListing>;
    RevertWikiPage(ctx: T, request: RevertWikiPageRequest): Promise<Empty>;
    GetWikiPageSettings(ctx: T, request: GetWikiPageSettingsRequest): Promise<WikiPageSettings>;
    UpdateWikiPageSettings(ctx: T, request: UpdateWikiPageSettingsRequest): Promise<WikiPageSettings>;
    AllowEditor(ctx: T, request: AllowEditorRequest): Promise<Empty>;
}
export declare enum WikiMethod {
    GetWikiPages = "GetWikiPages",
    GetWikiPage = "GetWikiPage",
    EditWikiPage = "EditWikiPage",
    HideWikiPageRevision = "HideWikiPageRevision",
    GetWikiPageRevisions = "GetWikiPageRevisions",
    GetWikiRevisions = "GetWikiRevisions",
    RevertWikiPage = "RevertWikiPage",
    GetWikiPageSettings = "GetWikiPageSettings",
    UpdateWikiPageSettings = "UpdateWikiPageSettings",
    AllowEditor = "AllowEditor"
}
export declare const WikiMethodList: WikiMethod[];
export declare function createWikiServer<T extends TwirpContext = TwirpContext>(service: WikiTwirp<T>): TwirpServer<WikiTwirp<TwirpContext<import("http").IncomingMessage, import("http").ServerResponse<import("http").IncomingMessage>>>, T>;
//# sourceMappingURL=wiki_svc.twirp.d.ts.map