import { SettingsRequest, SettingsResponse } from './settings.js';
export class SettingsClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.GetSettings.bind(this);
    }
    GetSettings(request) {
        const data = SettingsRequest.toJSON(request);
        const promise = this.rpc.request('devvit.plugin.settings.v1alpha.Settings', 'GetSettings', 'application/json', data);
        return promise.then((data) => SettingsResponse.fromJSON(data));
    }
}
export class SettingsClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.GetSettings.bind(this);
    }
    GetSettings(request) {
        const data = SettingsRequest.encode(request).finish();
        const promise = this.rpc.request('devvit.plugin.settings.v1alpha.Settings', 'GetSettings', 'application/protobuf', data);
        return promise.then((data) => SettingsResponse.decode(data));
    }
}
