/**
 * #streambroker.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { Observable } from "rxjs";
import { Metadata } from "../../../../lib/Types.js";
import { Empty } from "../../../google/protobuf/empty.js";
export interface Message {
    topic: string;
    value: string;
}
export interface Cursor {
    topic: string;
    offset: number;
    closeAtEnd: boolean;
}
export declare const Message: {
    $type: "devvit.plugin.streambroker.Message";
    encode(message: Message, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Message;
    fromJSON(object: any): Message;
    toJSON(message: Message): unknown;
    create(base?: DeepPartial<Message>): Message;
    fromPartial(object: DeepPartial<Message>): Message;
};
export declare const Cursor: {
    $type: "devvit.plugin.streambroker.Cursor";
    encode(message: Cursor, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Cursor;
    fromJSON(object: any): Cursor;
    toJSON(message: Cursor): unknown;
    create(base?: DeepPartial<Cursor>): Cursor;
    fromPartial(object: DeepPartial<Cursor>): Cursor;
};
export interface StreamBroker {
    Put(request: Message, metadata?: Metadata): Promise<Empty>;
    Get(request: Cursor, metadata?: Metadata): Observable<Message>;
}
export declare const StreamBrokerServiceName = "devvit.plugin.streambroker.StreamBroker";
export declare class StreamBrokerClientImpl implements StreamBroker {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Put(request: Message, metadata?: Metadata): Promise<Empty>;
    Get(request: Cursor, metadata?: Metadata): Observable<Message>;
}
export type StreamBrokerDefinition = typeof StreamBrokerDefinition;
export declare const StreamBrokerDefinition: {
    readonly name: "StreamBroker";
    readonly fullName: "devvit.plugin.streambroker.StreamBroker";
    readonly methods: {
        readonly put: {
            readonly name: "Put";
            readonly requestType: {
                $type: "devvit.plugin.streambroker.Message";
                encode(message: Message, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Message;
                fromJSON(object: any): Message;
                toJSON(message: Message): unknown;
                create(base?: DeepPartial<Message>): Message;
                fromPartial(object: DeepPartial<Message>): Message;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "google.protobuf.Empty";
                encode(_: Empty, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Empty;
                fromJSON(_: any): Empty;
                toJSON(_: Empty): unknown;
                create(base?: {}): Empty;
                fromPartial(_: {}): Empty;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        readonly get: {
            readonly name: "Get";
            readonly requestType: {
                $type: "devvit.plugin.streambroker.Cursor";
                encode(message: Cursor, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Cursor;
                fromJSON(object: any): Cursor;
                toJSON(message: Cursor): unknown;
                create(base?: DeepPartial<Cursor>): Cursor;
                fromPartial(object: DeepPartial<Cursor>): Cursor;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.plugin.streambroker.Message";
                encode(message: Message, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Message;
                fromJSON(object: any): Message;
                toJSON(message: Message): unknown;
                create(base?: DeepPartial<Message>): Message;
                fromPartial(object: DeepPartial<Message>): Message;
            };
            readonly responseStream: true;
            readonly options: {};
        };
    };
};
interface Rpc {
    request(service: string, method: string, data: Uint8Array, metadata?: Metadata): Promise<Uint8Array>;
    clientStreamingRequest(service: string, method: string, data: Observable<Uint8Array>, metadata?: Metadata): Promise<Uint8Array>;
    serverStreamingRequest(service: string, method: string, data: Uint8Array, metadata?: Metadata): Observable<Uint8Array>;
    bidirectionalStreamingRequest(service: string, method: string, data: Observable<Uint8Array>, metadata?: Metadata): Observable<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=streambroker.d.ts.map