import { TimerMessage } from './timer.js';
import { Empty } from '../../../google/protobuf/empty.js';
export class TimerClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.Wait.bind(this);
    }
    Wait(request) {
        const data = TimerMessage.toJSON(request);
        const promise = this.rpc.request('devvit.plugin.timer.Timer', 'Wait', 'application/json', data);
        return promise.then((data) => Empty.fromJSON(data));
    }
}
export class TimerClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.Wait.bind(this);
    }
    Wait(request) {
        const data = TimerMessage.encode(request).finish();
        const promise = this.rpc.request('devvit.plugin.timer.Timer', 'Wait', 'application/protobuf', data);
        return promise.then((data) => Empty.decode(data));
    }
}
