import { RenderPostRequest, RenderPostResponse } from './custom_post.js';
import { UIRequest, UIResponse } from '../../../ui/block_kit/v1beta/ui.js';
interface Rpc {
    request(service: string, method: string, contentType: 'application/json' | 'application/protobuf', data: object | Uint8Array): Promise<object | Uint8Array>;
}
export interface CustomPostClient {
    RenderPost(request: RenderPostRequest): Promise<RenderPostResponse>;
    RenderPostContent(request: UIRequest): Promise<UIResponse>;
    RenderPostComposer(request: UIRequest): Promise<UIResponse>;
}
export declare class CustomPostClientJSON implements CustomPostClient {
    private readonly rpc;
    constructor(rpc: Rpc);
    RenderPost(request: RenderPostRequest): Promise<RenderPostResponse>;
    RenderPostContent(request: UIRequest): Promise<UIResponse>;
    RenderPostComposer(request: UIRequest): Promise<UIResponse>;
}
export declare class CustomPostClientProtobuf implements CustomPostClient {
    private readonly rpc;
    constructor(rpc: Rpc);
    RenderPost(request: RenderPostRequest): Promise<RenderPostResponse>;
    RenderPostContent(request: UIRequest): Promise<UIResponse>;
    RenderPostComposer(request: UIRequest): Promise<UIResponse>;
}
export {};
//# sourceMappingURL=custom_post.twirp-client.d.ts.map