/**
 * #subredditv2.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
export declare enum SubredditType {
    ARCHIVED = 0,
    EMPLOYEES_ONLY = 1,
    GOLD_ONLY = 2,
    GOLD_RESTRICTED = 3,
    PRIVATE = 4,
    PUBLIC = 5,
    RESTRICTED = 6,
    USER = 7,
    UNRECOGNIZED = -1
}
export declare function subredditTypeFromJSON(object: any): SubredditType;
export declare function subredditTypeToJSON(object: SubredditType): number;
/** used with data-api */
export declare enum SubredditRating {
    UNKNOWN_SUBREDDIT_RATING = 0,
    /** E - everyone */
    E = 1,
    /** M1 - mature 1 */
    M1 = 2,
    /** M2 - mature 2 */
    M2 = 3,
    /** D - high-risk drug use */
    D = 4,
    /** V - violence & gore */
    V = 5,
    /** X - sexually explicit */
    X = 6,
    UNRECOGNIZED = -1
}
export declare function subredditRatingFromJSON(object: any): SubredditRating;
export declare function subredditRatingToJSON(object: SubredditRating): number;
export interface SubredditV2 {
    id: string;
    name: string;
    nsfw: boolean;
    type: SubredditType;
    spam: boolean;
    quarantined: boolean;
    topics: string[];
    rating: SubredditRating;
    subscribersCount: number;
    permalink: string;
}
export declare const SubredditV2: {
    $type: "devvit.reddit.v2alpha.SubredditV2";
    encode(message: SubredditV2, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SubredditV2;
    fromJSON(object: any): SubredditV2;
    toJSON(message: SubredditV2): unknown;
    create(base?: DeepPartial<SubredditV2>): SubredditV2;
    fromPartial(object: DeepPartial<SubredditV2>): SubredditV2;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=subredditv2.d.ts.map