/**
 * #runtime.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { Metadata } from "../../../../lib/Types.js";
import { Empty } from "../../../google/protobuf/empty.js";
import { LinkedBundle } from "../bundle.js";
export interface WorkerQuery {
    hostname: string;
}
export declare const WorkerQuery: {
    $type: "devvit.runtime.actor.WorkerQuery";
    encode(message: WorkerQuery, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): WorkerQuery;
    fromJSON(object: any): WorkerQuery;
    toJSON(message: WorkerQuery): unknown;
    create(base?: DeepPartial<WorkerQuery>): WorkerQuery;
    fromPartial(object: DeepPartial<WorkerQuery>): WorkerQuery;
};
/** Native implementation, spawns/terminates Workers. */
export interface RuntimeActor {
    NewWorker(request: LinkedBundle, metadata?: Metadata): Promise<Empty>;
    TerminateWorker(request: WorkerQuery, metadata?: Metadata): Promise<Empty>;
}
export declare const RuntimeActorServiceName = "devvit.runtime.actor.RuntimeActor";
export declare class RuntimeActorClientImpl implements RuntimeActor {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    NewWorker(request: LinkedBundle, metadata?: Metadata): Promise<Empty>;
    TerminateWorker(request: WorkerQuery, metadata?: Metadata): Promise<Empty>;
}
/** Native implementation, spawns/terminates Workers. */
export type RuntimeActorDefinition = typeof RuntimeActorDefinition;
export declare const RuntimeActorDefinition: {
    readonly name: "RuntimeActor";
    readonly fullName: "devvit.runtime.actor.RuntimeActor";
    readonly methods: {
        readonly newWorker: {
            readonly name: "NewWorker";
            readonly requestType: {
                $type: "devvit.runtime.LinkedBundle";
                encode(message: LinkedBundle, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): LinkedBundle;
                fromJSON(object: any): LinkedBundle;
                toJSON(message: LinkedBundle): unknown;
                create(base?: {
                    actor?: {
                        name?: string;
                        owner?: string;
                        version?: string;
                    } | undefined;
                    code?: string;
                    sourceMap?: string | undefined | undefined;
                    hostname?: string;
                    provides?: {
                        fullName?: string;
                        methods?: {
                            fullName?: string;
                            name?: string;
                            requestStream?: boolean;
                            responseStream?: boolean;
                            requestType?: string;
                            responseType?: string;
                        }[];
                        name?: string;
                        version?: string;
                    }[];
                    uses?: /*elided*/ any[];
                    buildInfo?: {
                        created?: Date | undefined;
                        dependencies?: {
                            [x: string]: string | undefined;
                        };
                        targetRuntime?: import("../bundle.js").TargetRuntime;
                    } | undefined;
                    assetsUrl?: string | undefined | undefined;
                    assets?: {
                        [x: string]: string | undefined;
                    };
                    webviewAssets?: {
                        [x: string]: string | undefined;
                    };
                    products?: {
                        [x: string]: string | undefined;
                    };
                    server?: {
                        code?: string;
                        sourceMap?: string;
                    } | undefined;
                }): LinkedBundle;
                fromPartial(object: {
                    actor?: {
                        name?: string;
                        owner?: string;
                        version?: string;
                    } | undefined;
                    code?: string;
                    sourceMap?: string | undefined | undefined;
                    hostname?: string;
                    provides?: {
                        fullName?: string;
                        methods?: {
                            fullName?: string;
                            name?: string;
                            requestStream?: boolean;
                            responseStream?: boolean;
                            requestType?: string;
                            responseType?: string;
                        }[];
                        name?: string;
                        version?: string;
                    }[];
                    uses?: /*elided*/ any[];
                    buildInfo?: {
                        created?: Date | undefined;
                        dependencies?: {
                            [x: string]: string | undefined;
                        };
                        targetRuntime?: import("../bundle.js").TargetRuntime;
                    } | undefined;
                    assetsUrl?: string | undefined | undefined;
                    assets?: {
                        [x: string]: string | undefined;
                    };
                    webviewAssets?: {
                        [x: string]: string | undefined;
                    };
                    products?: {
                        [x: string]: string | undefined;
                    };
                    server?: {
                        code?: string;
                        sourceMap?: string;
                    } | undefined;
                }): LinkedBundle;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "google.protobuf.Empty";
                encode(_: Empty, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Empty;
                fromJSON(_: any): Empty;
                toJSON(_: Empty): unknown;
                create(base?: {}): Empty;
                fromPartial(_: {}): Empty;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        readonly terminateWorker: {
            readonly name: "TerminateWorker";
            readonly requestType: {
                $type: "devvit.runtime.actor.WorkerQuery";
                encode(message: WorkerQuery, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): WorkerQuery;
                fromJSON(object: any): WorkerQuery;
                toJSON(message: WorkerQuery): unknown;
                create(base?: DeepPartial<WorkerQuery>): WorkerQuery;
                fromPartial(object: DeepPartial<WorkerQuery>): WorkerQuery;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "google.protobuf.Empty";
                encode(_: Empty, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Empty;
                fromJSON(_: any): Empty;
                toJSON(_: Empty): unknown;
                create(base?: {}): Empty;
                fromPartial(_: {}): Empty;
            };
            readonly responseStream: false;
            readonly options: {};
        };
    };
};
interface Rpc {
    request(service: string, method: string, data: Uint8Array, metadata?: Metadata): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=runtime.d.ts.map