import { LinkedBundle } from '../bundle.js';
import { Empty } from '../../../google/protobuf/empty.js';
import { WorkerQuery } from './runtime.js';
interface Rpc {
    request(service: string, method: string, contentType: 'application/json' | 'application/protobuf', data: object | Uint8Array): Promise<object | Uint8Array>;
}
export interface RuntimeActorClient {
    NewWorker(request: LinkedBundle): Promise<Empty>;
    TerminateWorker(request: WorkerQuery): Promise<Empty>;
}
export declare class RuntimeActorClientJSON implements RuntimeActorClient {
    private readonly rpc;
    constructor(rpc: Rpc);
    NewWorker(request: LinkedBundle): Promise<Empty>;
    TerminateWorker(request: WorkerQuery): Promise<Empty>;
}
export declare class RuntimeActorClientProtobuf implements RuntimeActorClient {
    private readonly rpc;
    constructor(rpc: Rpc);
    NewWorker(request: LinkedBundle): Promise<Empty>;
    TerminateWorker(request: WorkerQuery): Promise<Empty>;
}
export {};
//# sourceMappingURL=runtime.twirp-client.d.ts.map