import { LinkedBundle } from '../bundle.js';
import { Empty } from '../../../google/protobuf/empty.js';
import { WorkerQuery } from './runtime.js';
export class RuntimeActorClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.NewWorker.bind(this);
        this.TerminateWorker.bind(this);
    }
    NewWorker(request) {
        const data = LinkedBundle.toJSON(request);
        const promise = this.rpc.request('devvit.runtime.actor.RuntimeActor', 'NewWorker', 'application/json', data);
        return promise.then((data) => Empty.fromJSON(data));
    }
    TerminateWorker(request) {
        const data = WorkerQuery.toJSON(request);
        const promise = this.rpc.request('devvit.runtime.actor.RuntimeActor', 'TerminateWorker', 'application/json', data);
        return promise.then((data) => Empty.fromJSON(data));
    }
}
export class RuntimeActorClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.NewWorker.bind(this);
        this.TerminateWorker.bind(this);
    }
    NewWorker(request) {
        const data = LinkedBundle.encode(request).finish();
        const promise = this.rpc.request('devvit.runtime.actor.RuntimeActor', 'NewWorker', 'application/protobuf', data);
        return promise.then((data) => Empty.decode(data));
    }
    TerminateWorker(request) {
        const data = WorkerQuery.encode(request).finish();
        const promise = this.rpc.request('devvit.runtime.actor.RuntimeActor', 'TerminateWorker', 'application/protobuf', data);
        return promise.then((data) => Empty.decode(data));
    }
}
