/**
 * #health.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { Metadata } from "../../../../../lib/Types.js";
import { Empty } from "../../../../google/protobuf/empty.js";
export interface HealthStatus {
    start?: Date | undefined;
    end?: Date | undefined;
}
export declare const HealthStatus: {
    $type: "devvit.runtime.actor.v1alpha.HealthStatus";
    encode(message: HealthStatus, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): HealthStatus;
    fromJSON(object: any): HealthStatus;
    toJSON(message: HealthStatus): unknown;
    create(base?: DeepPartial<HealthStatus>): HealthStatus;
    fromPartial(object: DeepPartial<HealthStatus>): HealthStatus;
};
export interface Health {
    Check(request: Empty, metadata?: Metadata): Promise<HealthStatus>;
}
export declare const HealthServiceName = "devvit.runtime.actor.v1alpha.Health";
export declare class HealthClientImpl implements Health {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    Check(request: Empty, metadata?: Metadata): Promise<HealthStatus>;
}
export type HealthDefinition = typeof HealthDefinition;
export declare const HealthDefinition: {
    readonly name: "Health";
    readonly fullName: "devvit.runtime.actor.v1alpha.Health";
    readonly methods: {
        readonly check: {
            readonly name: "Check";
            readonly requestType: {
                $type: "google.protobuf.Empty";
                encode(_: Empty, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Empty;
                fromJSON(_: any): Empty;
                toJSON(_: Empty): unknown;
                create(base?: {}): Empty;
                fromPartial(_: {}): Empty;
            };
            readonly requestStream: false;
            readonly responseType: {
                $type: "devvit.runtime.actor.v1alpha.HealthStatus";
                encode(message: HealthStatus, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): HealthStatus;
                fromJSON(object: any): HealthStatus;
                toJSON(message: HealthStatus): unknown;
                create(base?: DeepPartial<HealthStatus>): HealthStatus;
                fromPartial(object: DeepPartial<HealthStatus>): HealthStatus;
            };
            readonly responseStream: false;
            readonly options: {};
        };
    };
};
interface Rpc {
    request(service: string, method: string, data: Uint8Array, metadata?: Metadata): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=health.d.ts.map