import { Empty } from '../../../../google/protobuf/empty.js';
import { HealthStatus } from './health.js';
export class HealthClientJSON {
    constructor(rpc) {
        this.rpc = rpc;
        this.Check.bind(this);
    }
    Check(request) {
        const data = Empty.toJSON(request);
        const promise = this.rpc.request('devvit.runtime.actor.v1alpha.Health', 'Check', 'application/json', data);
        return promise.then((data) => HealthStatus.fromJSON(data));
    }
}
export class HealthClientProtobuf {
    constructor(rpc) {
        this.rpc = rpc;
        this.Check.bind(this);
    }
    Check(request) {
        const data = Empty.encode(request).finish();
        const promise = this.rpc.request('devvit.runtime.actor.v1alpha.Health', 'Check', 'application/protobuf', data);
        return promise.then((data) => HealthStatus.decode(data));
    }
}
