/**
 * #enums.ts
 *
 * @packageDocumentation
 */
export declare enum BlockType {
    BLOCK_ROOT = 0,
    BLOCK_STACK = 1,
    BLOCK_TEXT = 2,
    BLOCK_BUTTON = 3,
    BLOCK_IMAGE = 4,
    BLOCK_SPACER = 5,
    BLOCK_ICON = 6,
    BLOCK_AVATAR = 7,
    /** @deprecated */
    BLOCK_FULLSNOO = 8,
    /** @deprecated */
    BLOCK_ANIMATION = 9,
    /** BLOCK_WEBVIEW - elements 100+ are privileged */
    BLOCK_WEBVIEW = 100,
    UNRECOGNIZED = -1
}
export declare function blockTypeFromJSON(object: any): BlockType;
export declare function blockTypeToJSON(object: BlockType): number;
export declare enum BlockActionType {
    ACTION_CLICK = 0,
    ACTION_WEBVIEW = 100,
    UNRECOGNIZED = -1
}
export declare function blockActionTypeFromJSON(object: any): BlockActionType;
export declare function blockActionTypeToJSON(object: BlockActionType): number;
export declare enum BlockRenderEventType {
    /** RENDER_INITIAL - First render of the UI on the user's device */
    RENDER_INITIAL = 0,
    /** RENDER_USER_ACTION - Render triggered by a user action */
    RENDER_USER_ACTION = 1,
    /** RENDER_EFFECT_EVENT - Render triggered as the result of an effect */
    RENDER_EFFECT_EVENT = 2,
    /** RENDER_CACHED - Render a version to be cached and used before the app can respond to RENDER_INITIAL */
    RENDER_CACHED = 3,
    UNRECOGNIZED = -1
}
export declare function blockRenderEventTypeFromJSON(object: any): BlockRenderEventType;
export declare function blockRenderEventTypeToJSON(object: BlockRenderEventType): number;
export declare enum BlockStackDirection {
    STACK_HORIZONTAL = 0,
    STACK_VERTICAL = 1,
    STACK_DEPTH = 2,
    UNRECOGNIZED = -1
}
export declare function blockStackDirectionFromJSON(object: any): BlockStackDirection;
export declare function blockStackDirectionToJSON(object: BlockStackDirection): number;
export declare enum BlockBorderWidth {
    BORDER_WIDTH_NONE = 0,
    BORDER_WIDTH_THIN = 1,
    BORDER_WIDTH_THICK = 2,
    UNRECOGNIZED = -1
}
export declare function blockBorderWidthFromJSON(object: any): BlockBorderWidth;
export declare function blockBorderWidthToJSON(object: BlockBorderWidth): number;
export declare enum BlockVerticalAlignment {
    ALIGN_TOP = 0,
    ALIGN_MIDDLE = 1,
    ALIGN_BOTTOM = 2,
    UNRECOGNIZED = -1
}
export declare function blockVerticalAlignmentFromJSON(object: any): BlockVerticalAlignment;
export declare function blockVerticalAlignmentToJSON(object: BlockVerticalAlignment): number;
export declare enum BlockHorizontalAlignment {
    ALIGN_START = 0,
    ALIGN_CENTER = 1,
    ALIGN_END = 2,
    UNRECOGNIZED = -1
}
export declare function blockHorizontalAlignmentFromJSON(object: any): BlockHorizontalAlignment;
export declare function blockHorizontalAlignmentToJSON(object: BlockHorizontalAlignment): number;
export declare enum BlockPadding {
    PADDING_NONE = 0,
    PADDING_XSMALL = 1,
    PADDING_SMALL = 2,
    PADDING_MEDIUM = 3,
    PADDING_LARGE = 4,
    UNRECOGNIZED = -1
}
export declare function blockPaddingFromJSON(object: any): BlockPadding;
export declare function blockPaddingToJSON(object: BlockPadding): number;
export declare enum BlockGap {
    GAP_NONE = 0,
    GAP_SMALL = 1,
    GAP_MEDIUM = 2,
    GAP_LARGE = 3,
    UNRECOGNIZED = -1
}
export declare function blockGapFromJSON(object: any): BlockGap;
export declare function blockGapToJSON(object: BlockGap): number;
export declare enum BlockRadius {
    RADIUS_NONE = 0,
    RADIUS_SMALL = 1,
    RADIUS_MEDIUM = 2,
    RADIUS_LARGE = 3,
    RADIUS_FULL = 100,
    UNRECOGNIZED = -1
}
export declare function blockRadiusFromJSON(object: any): BlockRadius;
export declare function blockRadiusToJSON(object: BlockRadius): number;
export declare enum BlockTextSize {
    TEXT_SIZE_MEDIUM = 0,
    TEXT_SIZE_XSMALL = 1,
    TEXT_SIZE_SMALL = 2,
    TEXT_SIZE_LARGE = 3,
    TEXT_SIZE_XLARGE = 4,
    TEXT_SIZE_XXLARGE = 5,
    UNRECOGNIZED = -1
}
export declare function blockTextSizeFromJSON(object: any): BlockTextSize;
export declare function blockTextSizeToJSON(object: BlockTextSize): number;
export declare enum BlockTextWeight {
    TEXT_WEIGHT_REGULAR = 0,
    TEXT_WEIGHT_BOLD = 1,
    UNRECOGNIZED = -1
}
export declare function blockTextWeightFromJSON(object: any): BlockTextWeight;
export declare function blockTextWeightToJSON(object: BlockTextWeight): number;
export declare enum BlockTextOutline {
    TEXT_OUTLINE_NONE = 0,
    TEXT_OUTLINE_THIN = 1,
    TEXT_OUTLINE_THICK = 2,
    UNRECOGNIZED = -1
}
export declare function blockTextOutlineFromJSON(object: any): BlockTextOutline;
export declare function blockTextOutlineToJSON(object: BlockTextOutline): number;
export declare enum BlockTextStyle {
    TEXT_STYLE_BODY = 0,
    TEXT_STYLE_METADATA = 1,
    TEXT_STYLE_HEADING = 2,
    UNRECOGNIZED = -1
}
export declare function blockTextStyleFromJSON(object: any): BlockTextStyle;
export declare function blockTextStyleToJSON(object: BlockTextStyle): number;
export declare enum BlockButtonSize {
    BUTTON_SIZE_MEDIUM = 0,
    BUTTON_SIZE_SMALL = 1,
    BUTTON_SIZE_LARGE = 2,
    UNRECOGNIZED = -1
}
export declare function blockButtonSizeFromJSON(object: any): BlockButtonSize;
export declare function blockButtonSizeToJSON(object: BlockButtonSize): number;
export declare enum BlockButtonAppearance {
    BUTTON_APPEARANCE_SECONDARY = 0,
    BUTTON_APPEARANCE_PRIMARY = 1,
    BUTTON_APPEARANCE_PLAIN = 2,
    BUTTON_APPEARANCE_BORDERED = 3,
    BUTTON_APPEARANCE_MEDIA = 4,
    BUTTON_APPEARANCE_DESTRUCTIVE = 5,
    BUTTON_APPEARANCE_CAUTION = 6,
    BUTTON_APPEARANCE_SUCCESS = 7,
    UNRECOGNIZED = -1
}
export declare function blockButtonAppearanceFromJSON(object: any): BlockButtonAppearance;
export declare function blockButtonAppearanceToJSON(object: BlockButtonAppearance): number;
export declare enum BlockImageResizeMode {
    IMAGE_RESIZE_FIT = 0,
    IMAGE_RESIZE_FILL = 1,
    IMAGE_RESIZE_COVER = 2,
    IMAGE_RESIZE_NONE = 3,
    IMAGE_RESIZE_SCALE_DOWN = 4,
    UNRECOGNIZED = -1
}
export declare function blockImageResizeModeFromJSON(object: any): BlockImageResizeMode;
export declare function blockImageResizeModeToJSON(object: BlockImageResizeMode): number;
export declare enum BlockSpacerSize {
    SPACER_SMALL = 0,
    SPACER_XSMALL = 1,
    SPACER_MEDIUM = 2,
    SPACER_LARGE = 3,
    UNRECOGNIZED = -1
}
export declare function blockSpacerSizeFromJSON(object: any): BlockSpacerSize;
export declare function blockSpacerSizeToJSON(object: BlockSpacerSize): number;
export declare enum BlockSpacerShape {
    SPACER_INVISIBLE = 0,
    SPACER_THIN = 1,
    SPACER_SQUARE = 2,
    UNRECOGNIZED = -1
}
export declare function blockSpacerShapeFromJSON(object: any): BlockSpacerShape;
export declare function blockSpacerShapeToJSON(object: BlockSpacerShape): number;
export declare enum BlockIconSize {
    ICON_SIZE_MEDIUM = 0,
    ICON_SIZE_XSMALL = 1,
    ICON_SIZE_SMALL = 2,
    ICON_SIZE_LARGE = 3,
    UNRECOGNIZED = -1
}
export declare function blockIconSizeFromJSON(object: any): BlockIconSize;
export declare function blockIconSizeToJSON(object: BlockIconSize): number;
export declare enum BlockAvatarFacing {
    AVATAR_FACING_LEFT = 0,
    AVATAR_FACING_RIGHT = 1,
    UNRECOGNIZED = -1
}
export declare function blockAvatarFacingFromJSON(object: any): BlockAvatarFacing;
export declare function blockAvatarFacingToJSON(object: BlockAvatarFacing): number;
export declare enum BlockAvatarSize {
    AVATAR_SIZE_SMALL = 0,
    AVATAR_SIZE_XXSMALL = 1,
    AVATAR_SIZE_XSMALL = 2,
    AVATAR_SIZE_MEDIUM = 3,
    AVATAR_SIZE_LARGE = 4,
    AVATAR_SIZE_XLARGE = 5,
    AVATAR_SIZE_XXLARGE = 6,
    AVATAR_SIZE_XXXLARGE = 7,
    UNRECOGNIZED = -1
}
export declare function blockAvatarSizeFromJSON(object: any): BlockAvatarSize;
export declare function blockAvatarSizeToJSON(object: BlockAvatarSize): number;
export declare enum BlockAvatarBackground {
    AVATAR_BG_LIGHT = 0,
    AVATAR_BG_DARK = 1,
    UNRECOGNIZED = -1
}
export declare function blockAvatarBackgroundFromJSON(object: any): BlockAvatarBackground;
export declare function blockAvatarBackgroundToJSON(object: BlockAvatarBackground): number;
/** @deprecated */
export declare enum BlockFullSnooSize {
    FULLSNOO_SMALL = 0,
    FULLSNOO_XSMALL = 1,
    FULLSNOO_MEDIUM = 2,
    FULLSNOO_LARGE = 3,
    FULLSNOO_XLARGE = 4,
    FULLSNOO_XXLARGE = 5,
    UNRECOGNIZED = -1
}
export declare function blockFullSnooSizeFromJSON(object: any): BlockFullSnooSize;
export declare function blockFullSnooSizeToJSON(object: BlockFullSnooSize): number;
/** @deprecated */
export declare enum BlockAnimationType {
    ANIM_LOTTIE = 0,
    UNRECOGNIZED = -1
}
export declare function blockAnimationTypeFromJSON(object: any): BlockAnimationType;
export declare function blockAnimationTypeToJSON(object: BlockAnimationType): number;
/** @deprecated */
export declare enum BlockAnimationLoopMode {
    ANIM_LOOP_REPEAT = 0,
    ANIM_LOOP_BOUNCE = 1,
    UNRECOGNIZED = -1
}
export declare function blockAnimationLoopModeFromJSON(object: any): BlockAnimationLoopMode;
export declare function blockAnimationLoopModeToJSON(object: BlockAnimationLoopMode): number;
/** @deprecated */
export declare enum BlockAnimationDirection {
    ANIM_DIR_FORWARD = 0,
    ANIM_DIR_BACKWARD = 1,
    UNRECOGNIZED = -1
}
export declare function blockAnimationDirectionFromJSON(object: any): BlockAnimationDirection;
export declare function blockAnimationDirectionToJSON(object: BlockAnimationDirection): number;
export declare enum BlockSizeUnit {
    SIZE_UNIT_PERCENT = 0,
    SIZE_UNIT_PIXELS = 1,
    UNRECOGNIZED = -1
}
export declare function blockSizeUnitFromJSON(object: any): BlockSizeUnit;
export declare function blockSizeUnitToJSON(object: BlockSizeUnit): number;
export declare enum BlockTextOverflow {
    TEXT_OVERFLOW_CLIP = 0,
    TEXT_OVERFLOW_ELLIPSE = 1,
    UNRECOGNIZED = -1
}
export declare function blockTextOverflowFromJSON(object: any): BlockTextOverflow;
export declare function blockTextOverflowToJSON(object: BlockTextOverflow): number;
//# sourceMappingURL=enums.d.ts.map