/**
 * #rendering.ts
 *
 * @packageDocumentation
 */
import _m0 from "protobufjs/minimal.js";
import { Block } from "./block.js";
import { BlockRenderEventType } from "./enums.js";
export interface BlockRenderRequest {
    /** What triggered this render request */
    type: BlockRenderEventType;
    /**
     * ID to differentiate between similar events of the same type
     * such as an actionId for USER_ACTION events
     */
    id?: string | undefined;
    /** Additional data from the event, if any */
    data?: {
        [key: string]: any;
    } | undefined;
}
export interface BlockRenderResponse {
    /** A BLOCK_ROOT element */
    ui?: Block | undefined;
}
export declare const BlockRenderRequest: {
    $type: "devvit.ui.block_kit.v1beta.BlockRenderRequest";
    encode(message: BlockRenderRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): BlockRenderRequest;
    fromJSON(object: any): BlockRenderRequest;
    toJSON(message: BlockRenderRequest): unknown;
    create(base?: DeepPartial<BlockRenderRequest>): BlockRenderRequest;
    fromPartial(object: DeepPartial<BlockRenderRequest>): BlockRenderRequest;
};
export declare const BlockRenderResponse: {
    $type: "devvit.ui.block_kit.v1beta.BlockRenderResponse";
    encode(message: BlockRenderResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): BlockRenderResponse;
    fromJSON(object: any): BlockRenderResponse;
    toJSON(message: BlockRenderResponse): unknown;
    create(base?: DeepPartial<BlockRenderResponse>): BlockRenderResponse;
    fromPartial(object: DeepPartial<BlockRenderResponse>): BlockRenderResponse;
};
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
//# sourceMappingURL=rendering.d.ts.map