/**
 * #type.ts
 *
 * @packageDocumentation
 */
export declare enum FormFieldType {
    /** STRING - Single-line string */
    STRING = 0,
    /** PARAGRAPH - Multi-line string */
    PARAGRAPH = 1,
    /** NUMBER - Number input */
    NUMBER = 2,
    /** BOOLEAN - Checkbox, switch */
    BOOLEAN = 3,
    /** LIST - Collect multiple entries of a single type */
    LIST = 4,
    /** SELECTION - Provide a list of options for the user to choose from */
    SELECTION = 5,
    /** GROUP - Create a labeled subsection of the form with nested fields */
    GROUP = 6,
    /** IMAGE - Image upload - value is a URL for the uploaded image */
    IMAGE = 7,
    UNRECOGNIZED = -1
}
export declare function formFieldTypeFromJSON(object: any): FormFieldType;
export declare function formFieldTypeToJSON(object: FormFieldType): number;
//# sourceMappingURL=type.d.ts.map